﻿
package net.kaikoga.fusalg.area {
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.util.FusalgMath;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class ABoundAreaContext {

		public var nowLeft:int;
		public var nowRight:int;
		
		private var minLeft:int;
		private var maxRight:int;
		
		public function ABoundAreaContext(left:int = 2, right:int = 8, inside:Boolean = false) {
			super();
			this.nowLeft = left;
			this.nowRight = right;
			this.minLeft = inside ? 1 : 0;
			this.maxRight = inside ? Field.ROW_CELLS - 2 : Field.ROW_CELLS - 1;
		}
		
		public function nextRow(morphrate:Number = 1, minbound:int = 4):void {
			switch (FusalgMath.randomInt(0, 4 / morphrate)) {
				case 0:
				if (this.nowLeft < this.nowRight - minbound) {
					this.nowLeft++;
				}
				break;
				case 1:
				if (this.nowLeft < this.nowRight - minbound) {
					this.nowRight--;
				}
				break;
				case 2:
				if (this.nowLeft > this.minLeft) {
					this.nowLeft--;
				}
				break;
				case 3:
				if (this.nowRight < this.maxRight) {
					this.nowRight++;
				}
				break;
			}
		}
		
	}
	
}
