﻿
package net.kaikoga.fusalg.area {
	
	import net.kaikoga.fusalg.area.AArea;
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.cellinfo.CellInfoSet;
	import net.kaikoga.fusalg.cellinfo.FieldCellInfos;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.enemya.Umaa;
	import net.kaikoga.fusalg.util.QuotientSwitch;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class AFieldArea extends ALinkArea {
		
		private var chipInfos:FieldCellInfos;
		public var shrubRate:Number = 0.2;
		public var bushRate:Number = 0;
		public var rockRate:Number = 0;
		private var groundTypes:Array;
		
		public function AFieldArea(length:int) {
			this.chipInfos = FieldCellInfos.getInstance();
			var gs:CellInfoSet = this.chipInfos.grassSet1;
			this.groundTypes = [null, gs, gs, gs, gs, gs, gs, gs, gs, gs, gs]
			super(length, false, false, this.chipInfos.sideSet);
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music1);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			for (var i:int = 1; i < Field.ROW_CELLS; i++) {
				var cell:Cell = Cell(row.cells[i]);
				var qs:QuotientSwitch = QuotientSwitch.qs();
				if (qs.rate(this.shrubRate)) {
					cell.reset(this.chipInfos.shrub);
					this.groundTypes[i] = this.chipInfos.grassSet1;
				} else if (qs.rate(this.bushRate)) {
					cell.reset(this.chipInfos.bush);
				} else if (qs.rate(this.rockRate)) {
					cell.reset(this.chipInfos.rock);
					this.groundTypes[i] = this.chipInfos.groundSet1;
				} else {
					this.buildLinkCell(cell, this.groundTypes[i], index);
				}
			}
			super.buildRow(field, row, index);
		}
		
	}
	
}
