﻿
package net.kaikoga.fusalg.area {

	import net.kaikoga.fusalg.cellinfo.CellInfo;
	import net.kaikoga.fusalg.cellinfo.CellInfoSet;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.field.Row;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class ALinkArea extends AArea {
		
		private var top:int;
		private var bottom:int;
		private var lsideSet:CellInfoSet;
		private var rsideSet:CellInfoSet;
		
		public function ALinkArea(length:int, linktop:Boolean, linkbottom:Boolean, lsideset:CellInfoSet, rsideset:CellInfoSet = null) {
			super((length > 4) ? length : 4);
			this.top = linktop ? -1 : 0;
			this.bottom = linkbottom ? length: length - 1;
			this.lsideSet = lsideset;
			this.rsideSet = rsideset || lsideset;
		}
		
		protected function buildLinkCell(cell:Cell, cellinfoset:CellInfoSet, index:int):void {
			cell.reset(cellinfoset.getCellInfo(index, this.top, this.bottom));
		}
		
		protected function buildCell(cell:Cell, cellinfo:CellInfo, index:int = 0):void {
			cell.reset(cellinfo);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			row.resetSideChip(this.lsideSet.getCellInfo(index, this.top, this.bottom), this.rsideSet.getCellInfo(index, this.top, this.bottom));
		}
		
	}
	
}
