﻿
package net.kaikoga.fusalg.area.area1 {
	
	import net.kaikoga.fusalg.area.AArea;
	import net.kaikoga.fusalg.area.ALinkArea;
	import net.kaikoga.fusalg.cellinfo.CaveCellInfos;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.enemya.Umaa;
	import net.kaikoga.fusalg.util.FusalgMath;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class ACaveArea extends ALinkArea {
		
		private var chipInfos:CaveCellInfos;
		protected var boulderRate:Number;
		protected var boulderLRate:Number;
		
		public function ACaveArea(length:int, linktop:Boolean, linkbottom:Boolean) {
			this.chipInfos = CaveCellInfos.getInstance();
			super(length, linktop, linkbottom, this.chipInfos.sideSet);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			var setindex:int = 0;
			for (var i:int = 1; i < Field.ROW_CELLS; i++) {
				var cell:Cell = Cell(row.cells[i]);
				if (Math.random() < boulderRate) {
					cell.reset(this.chipInfos.boulder);
				} else {
					switch (setindex) {
						case 0:
						this.buildLinkCell(cell, this.chipInfos.groundSet1, index);
						break;
						case 1:
						this.buildLinkCell(cell, this.chipInfos.groundSet2, index);
						break;
						case 2:
						this.buildLinkCell(cell, this.chipInfos.groundSet3, index);
						break;
					}
				}
				if (++setindex > 2) {
					setindex = 0;
				}
			}
			if (Math.random() < boulderLRate) {
				this.buildCell(Cell(row.cells[FusalgMath.randomInt(1, 9)]), this.chipInfos.boulderL);
			}
			super.buildRow(field, row, index);
		}
		
	}
	
}
