﻿
package net.kaikoga.fusalg.area.area1 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.allystub.AmiraStub;
	import net.kaikoga.fusalg.mortal.enemya.Umaa;
	import net.kaikoga.fusalg.mortal.enemyb.GhostS;
	import net.kaikoga.fusalg.mortal.enemyc.InsectB;
	import net.kaikoga.fusalg.strings.FusalgStrings;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area1_2 extends ACaveArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_1_2_1"
			],
			waltz:[
				"waltz_1_2_1"
			],
			ghanae:[
				"ghanae_1_2_1"
			],
			silruy:[
				"silruy_1_2_1"
			]
		}
		
		public function Area1_2(field:Field) {
			super(32 -  field.flags.getProceeding(6, 0, 10, 0) * 32, true, false);
			this.boulderRate = 0.1;
			this.boulderLRate = 0.1;
			this.areaText = " AREA 1-2";
			this.areaNameText = '  "CAVE"  ';
			this.targetName = "insectl";
			this.areaMessages = AREA_MESSAGES;
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch(index & 3) {
				case 0:
				field.addEnemy(new Umaa());
				break;
				case 1:
				field.addEnemy(new InsectB());
				break;
				case 2:
				field.addEnemy(new GhostS());
				break;
			}
		}
		
		override public function onEnterSelf(field:Field):void {
			field.addEnemy(new AmiraStub(), 160, -32);
			field.messageLayer.message(field, FusalgStrings.getString("area1_2"));
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music2);
		}
		
		override public function nextArea(field:Field):void {
			if (field.flags.timeIsBefore(10, 0)) {
				field.nextArea(new Area1_3(field));
			} else {
				field.nextArea(new Area1_Exit());
			}
		}
	}
	
}
