﻿
package net.kaikoga.fusalg.area.area1 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.boss.InsectL;
	import net.kaikoga.fusalg.mortal.enemya.Umaa;
	import net.kaikoga.fusalg.mortal.enemyc.InsectB;
	import net.kaikoga.fusalg.mortal.enemyd.TrentS;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area1_3 extends ACaveArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_1_3_1"
			],
			waltz:[
				"waltz_1_3_1"
			],
			ghanae:[
				"ghanae_1_3_1"
			],
			silruy:[
				"silruy_1_3_1"
			]
		}
		
		private var boss:InsectL;
		
		public function Area1_3(field:Field) {
			super(32, true, true);
			this.boulderRate = 0;
			this.boulderLRate = 0.1;
			this.areaText = " AREA 1-3";
			this.areaNameText = '  "CAVE"  ';
			this.targetName = "insectl";
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function getBossLife():int {
			return this.boss ? this.boss.life : 0;
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch(index & 3) {
				case 0:
				field.addEnemy(new Umaa());
				field.addEnemy(new InsectB());
				break;
				case 2:
				field.addEnemy(new TrentS());
				break;
			}
			if (this.boss.life <= 0) {
				this.nextArea(field);
			}
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			this.boss = new InsectL()
			field.addEnemy(this.boss);
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music4);
		}
		
		override public function nextArea(field:Field):void {
			if (field.flags.timeIsBefore(8, 0)) {
				field.nextArea(new Area1_4(field));
			} else {
				field.nextArea(new Area1_Exit());
			}
		}
	}
	
}
