﻿
package net.kaikoga.fusalg.area.area1 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.enemya.Umaa;
	import net.kaikoga.fusalg.mortal.enemyd.TrentS;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area1_4 extends ACaveArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_1_4_1"
			],
			waltz:[
				"waltz_1_4_1"
			],
			ghanae:[
				"ghanae_1_4_1"
			],
			silruy:[
				"silruy_1_4_1"
			]
		}
		
		public function Area1_4(field:Field) {
			super(32, true, true);
			this.boulderRate = 0.2;
			this.boulderLRate = 0.6;
			this.areaText = " AREA 1-4";
			this.areaNameText = '  "CAVE"  ';
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music2);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch(index & 3) {
				case 0:
				field.addEnemy(new Umaa());
				break;
				case 2:
				field.addEnemy(new TrentS());
				break;
			}
		}
		
		override public function nextArea(field:Field):void {
			field.nextArea(new Area1_Exit());
		}
	}
	
}
