﻿
package net.kaikoga.fusalg.area.area2 {
	
	import net.kaikoga.fusalg.area.ALinkArea;
	import net.kaikoga.fusalg.cellinfo.CellInfo;
	import net.kaikoga.fusalg.cellinfo.MansionCellInfos;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.util.FusalgMath;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class AMansionArea extends ALinkArea {
		
		private var chipInfos:MansionCellInfos;
		protected var nowWall:int;
		protected var wallRate:Number = 0.8;
		protected var ruinRate:Number = 0.8;
		protected var coffinRate:Number = 0.2;
		protected var skeletonRate:Number = 0.1;
		
		public function AMansionArea(length:int, linktop:Boolean, linkbottom:Boolean, nowwall:int = -1) {
			this.nowWall = nowwall;
			this.chipInfos = MansionCellInfos.getInstance();
			super(length, linktop, linkbottom, this.chipInfos.sideSet);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			var i:int = 1;
			for (i = 1; i < Field.ROW_CELLS; i++) {
				if (Math.random() < this.skeletonRate) {
					this.buildCell(Cell(row.cells[i]), this.chipInfos.skeleton, index);
				} else if (Math.random() < this.skeletonRate) {
					this.buildCell(Cell(row.cells[i]), this.chipInfos.carpet, index);
				} else {
					this.buildLinkCell(Cell(row.cells[i]), this.chipInfos.groundSet, index);
				}
			}
			if (Math.random() < this.coffinRate) {
				var coffincellinfo:CellInfo = (Math.random() < 0.5) ? this.chipInfos.coffin1 : this.chipInfos.coffin2;
				this.buildCell(Cell(row.cells[FusalgMath.randomInt(2, 8)]), coffincellinfo);
			}
			if ((Math.random() < this.wallRate) || (this.nowWall == -1)) {
				this.wallRate = -1;
				var oldwall:int = this.nowWall;
				this.nowWall = FusalgMath.randomInt(1, 9);
				for (i = 1; i <= 9; i++) {
					var wallcellinfo:CellInfo;
					switch (i) {
						case oldwall:
						wallcellinfo = this.chipInfos.wallSet.top;
						break;
						case this.nowWall:
						wallcellinfo = this.chipInfos.wallSet.bottom;
						break;
						default:
						wallcellinfo = (Math.random() < this.ruinRate) ? this.chipInfos.wallSet.horiz : null;
						break;
					}
					if (wallcellinfo) {
						this.buildCell(Cell(row.cells[i]), wallcellinfo);
					}
				}
			} else {
				this.wallRate = (0.5 + this.wallRate) / 1.5;
				if ((this.nowWall > 0) && (Math.random() < this.ruinRate)) {
					this.buildCell(Cell(row.cells[this.nowWall]), this.chipInfos.wallSet.vert);
				}
			}
			super.buildRow(field, row, index);
		}
		
	}
	
}
