﻿
package net.kaikoga.fusalg.area.area2 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.cellinfo.CellInfo;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.allystub.WaltzStub;
	import net.kaikoga.fusalg.mortal.enemya.Umaa;
	import net.kaikoga.fusalg.mortal.enemyb.GhostS;
	import net.kaikoga.fusalg.mortal.enemyb.GhostM;
	import net.kaikoga.fusalg.mortal.enemye.Zombie;
	import net.kaikoga.fusalg.strings.FusalgStrings;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area2_2 extends AMansionArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_2_2_1"
			],
			waltz:[
				"waltz_2_2_1"
			],
			ghanae:[
				"ghanae_2_2_1"
			],
			silruy:[
				"silruy_2_2_1"
			]
		}
		
		public function Area2_2(field:Field) {
			super(32 - field.flags.getProceeding(8, 0, 12, 0) * 32, true, false, -1);
			this.ruinRate = 0.7;
			this.skeletonRate = 0.01;
			this.areaText = " AREA 2-2";
			this.areaNameText = ' "MANSION"';
			this.targetName = "mansion";
			this.areaMessages = AREA_MESSAGES;
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch (index & 3) {
				case 0:
				field.addEnemy(new Umaa());
				break;
				case 1:
				field.addEnemy(new GhostS());
				break;
				case 2:
				field.addEnemy(new Zombie());
				break;
				case 3:
				field.addEnemy(new GhostM());
				break;
			}
		}
		
		override public function onEnterSelf(field:Field):void {
			field.addEnemy(new WaltzStub(), 160, -32);
			field.messageLayer.message(field, FusalgStrings.getString("area2_2"));
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music3);
		}
		
		override public function nextArea(field:Field):void {
			if (field.flags.timeIsBefore(12, 0)) {
				field.nextArea(new Area2_3(field, this.nowWall));
			} else {
				field.nextArea(new Area2_Exit());
			}
		}
	}
	
}
