﻿
package net.kaikoga.fusalg.area.area2 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.cellinfo.CellInfo;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.boss.Mansion;
	import net.kaikoga.fusalg.mortal.boss.Resident;
	import net.kaikoga.fusalg.mortal.enemya.Umaa;
	import net.kaikoga.fusalg.mortal.enemye.Zombie;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area2_3 extends AMansionArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_2_3_1"
			],
			waltz:[
				"waltz_2_3_1"
			],
			ghanae:[
				"ghanae_2_3_1"
			],
			silruy:[
				"silruy_2_3_1"
			]
		}
		
		private var boss:Mansion;
		
		public function Area2_3(field:Field, nowwall:int) {
			super(32, true, true, nowwall);
			this.ruinRate = 0.5;
			this.coffinRate = 0;
			this.skeletonRate = 0.01;
			this.areaText = " AREA 2-3";
			this.areaNameText = ' "MANSION"';
			this.targetName = "mansion";
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function getBossLife():int {
			return this.boss ? this.boss.life : 0;
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch (index & 3) {
				case 1:
				case 3:
				field.addEnemy(new Umaa());
				break;
				case 2:
				field.addEnemy(new Zombie());
				field.addEnemy(new Zombie());
				break;
			}
			if (this.boss.life <= 0) {
				this.nextArea(field);
			} else {
				var resident:Resident = this.boss.spawnResident();
				if (resident) {
					field.addEnemy(resident);
				}
			}
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			this.boss = new Mansion();
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music4);
		}
		
		override public function nextArea(field:Field):void {
			if (field.flags.timeIsBefore(10, 0)) {
				field.nextArea(new Area2_4(field, this.nowWall));
			} else {
				field.nextArea(new Area2_Exit());
			}
		}
		
	}
	
}
