﻿
package net.kaikoga.fusalg.area.area2 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.cellinfo.CellInfo;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.enemya.Umaa;
	import net.kaikoga.fusalg.mortal.enemyb.GhostM;
	import net.kaikoga.fusalg.mortal.enemye.Lich;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area2_4 extends AMansionArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_2_4_1"
			],
			waltz:[
				"waltz_2_4_1"
			],
			ghanae:[
				"ghanae_2_4_1"
			],
			silruy:[
				"silruy_2_4_1"
			]
		}
		
		public function Area2_4(field:Field, nowwall:int) {
			super(32, true, true, nowwall);
			this.ruinRate = 0.9;
			this.coffinRate = 0.3;
			this.skeletonRate = 0.1;
			this.areaText = " AREA 2-4";
			this.areaNameText = ' "MANSION"';
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music3);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch (index & 3) {
				case 1:
				field.addEnemy(new Umaa());
				break;
				case 2:
				field.addEnemy(new GhostM());
				break;
				case 3:
				field.addEnemy(new Lich());
				break;
			}
		}
		
		override public function nextArea(field:Field):void {
			field.nextArea(new Area2_Exit());
		}
		
	}
	
}
