﻿
package net.kaikoga.fusalg.area.area3 {
	
	import net.kaikoga.fusalg.area.ALinkArea;
	import net.kaikoga.fusalg.cellinfo.AvenueCellInfos;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class AAvenueArea extends ALinkArea {
		
		private var chipInfos:AvenueCellInfos;
		protected var context:AvenueAreaContext;
		public var bushRate:Number = 0.2;
		public var rockRate:Number = 0.01;
		
		public function AAvenueArea(length:int, linkTop:Boolean, linkBottom:Boolean, context:AvenueAreaContext = null) {
			this.context = context || new AvenueAreaContext();
			this.chipInfos = AvenueCellInfos.getInstance();
			super(length, linkTop, linkBottom, this.chipInfos.lsideSet, this.chipInfos.rsideSet);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			var i:int;
			var cell:Cell;
			for (i = 1; i < Field.ROW_CELLS; i++) {
				cell = Cell(row.cells[i]);
				if (Math.random() < this.bushRate) {
					cell.reset(this.chipInfos.bush);
				} else {
					cell.reset(this.chipInfos.grass1);
				}
			}
			var oldleft:int = this.context.nowLeft;
			var oldright:int = this.context.nowRight;
			this.context.nextRow(0.25, 1);
			var avleft:int = (oldleft < this.context.nowLeft) ? oldleft : this.context.nowLeft;
			var avright:int = (oldright > this.context.nowRight) ? oldright : this.context.nowRight;
			for (i = avleft; i <= avright; i++) {
				cell = Cell(row.cells[i]);
				if ((i < oldleft) || (i > oldright)) {
					cell.reset(this.chipInfos.groundSet1.bottom);
				} else if ((i < this.context.nowLeft) || (i > this.context.nowRight)) {
					cell.reset(this.chipInfos.groundSet1.top);
				} else if (Math.random() > this.rockRate) {
					cell.reset(this.chipInfos.groundSet1.vert);
				} else {
					cell.reset(this.chipInfos.rock);
				}
			}
			super.buildRow(field, row, index);
		}
		
	}
	
}
