﻿
package net.kaikoga.fusalg.area.area3 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.allystub.GhanaeStub;
	import net.kaikoga.fusalg.mortal.enemya.Jien;
	import net.kaikoga.fusalg.mortal.enemyc.InsectB;
	import net.kaikoga.fusalg.mortal.enemyd.TrentS;
	import net.kaikoga.fusalg.strings.FusalgStrings;
	import net.kaikoga.fusalg.util.FusalgMath;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area3_1 extends AAvenueArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_3_1_1"
			],
			waltz:[
				"waltz_3_1_1"
			],
			ghanae:[
				"ghanae_3_1_1"
			],
			silruy:[
				"silruy_3_1_1"
			]
		}
		
		private var ghanaeRow:int;
		
		public function Area3_1(field:Field) {
			super(32 - field.flags.getProceeding(10, 0, 14, 0) * 32, true, false);
			this.bushRate = 0.2;
			this.rockRate = 0;
			this.areaText = " AREA 3-1";
			this.areaNameText = ' "AVENUE" ';
			this.ghanaeRow = FusalgMath.randomInt(10, 28);
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music1);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch(index & 3) {
				case 0:
				field.addEnemy(new Jien());
				break;
				case 1:
				field.addEnemy(new InsectB());
				break;
				case 2:
				field.addEnemy(new TrentS());
				break;
			}
			if (index == this.ghanaeRow) {
				field.addEnemy(new GhanaeStub(), -1, -32);
				field.messageLayer.message(field, FusalgStrings.getString("area3_1"));
			}
		}
		
		override public function nextArea(field:Field):void {
			if (field.flags.timeIsBefore(10, 0)) {
				field.nextArea(new Area3_2(field, this.context));
			} else if (field.flags.timeIsBefore(11, 0)) {
				field.nextArea(new Area3_3(field, this.context));
			} else {
				field.nextArea(new Area3_Exit());
			}
		}
		
	}
	
}
