﻿
package net.kaikoga.fusalg.area.area3 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.enemya.Umaa;
	import net.kaikoga.fusalg.mortal.enemya.Jien;
	import net.kaikoga.fusalg.mortal.enemyd.TrentS;
	import net.kaikoga.fusalg.mortal.enemyd.TrentM;
	import net.kaikoga.fusalg.mortal.enemyf.AxeRogue;
	import net.kaikoga.fusalg.mortal.enemyf.SwordRogue;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area3_2 extends AAvenueArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_3_2_1"
			],
			waltz:[
				"waltz_3_2_1"
			],
			ghanae:[
				"ghanae_3_2_1"
			],
			silruy:[
				"silruy_3_2_1"
			]
		}
		
		public function Area3_2(field:Field, context:AvenueAreaContext) {
			super(32, true, true, context);
			this.bushRate = 0.3;
			this.rockRate = 0.15;
			this.areaText = " AREA 3-2";
			this.areaNameText = ' "AVENUE" ';
			this.areaMessages = AREA_MESSAGES;
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch (index) {
				case 30:
				field.addEnemy(new SwordRogue());
				break;
				case 29:
				field.addEnemy(new AxeRogue());
				break;
				default:
				switch (index & 3) {
					case 0:
					field.addEnemy(new TrentS());
					break;
					case 1:
					field.addEnemy(new Umaa());
					break;
					case 2:
					field.addEnemy(new TrentM());
					break;
					case 3:
					field.addEnemy(new Jien());
					break;
				}
				break;
			}
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music4);
		}
		
		override public function nextArea(field:Field):void {
			if (field.flags.timeIsBefore(11, 0)) {
				field.nextArea(new Area3_3(field, this.context));
			} else {
				field.nextArea(new Area3_Exit());
			}
		}
		
	}
	
}
