﻿
package net.kaikoga.fusalg.area.area3 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.enemya.Jien;
	import net.kaikoga.fusalg.mortal.enemyc.InsectR;
	import net.kaikoga.fusalg.mortal.enemyd.TrentM;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area3_3 extends AAvenueArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_3_3_1"
			],
			waltz:[
				"waltz_3_3_1"
			],
			ghanae:[
				"ghanae_3_3_1"
			],
			silruy:[
				"silruy_3_3_1"
			]
		}
		
		public function Area3_3(field:Field, context:AvenueAreaContext) {
			super(48 - field.flags.getProceeding(8, 0, 11, 0) * 48, true, true, context);
			this.bushRate = 0.4;
			this.rockRate = 0.05;
			this.areaText = " AREA 3-3";
			this.areaNameText = ' "AVENUE" ';
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music1);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch (index & 3) {
				case 0:
				field.addEnemy(new Jien());
				field.addEnemy(new InsectR());
				break;
				case 2:
				field.addEnemy(new TrentM());
				field.addEnemy(new InsectR());
				break;
			}
		}
		
		override public function nextArea(field:Field):void {
			field.nextArea(new Area3_Exit());
		}
	}
	
}
