﻿
package net.kaikoga.fusalg.area.area4 {
	
	import net.kaikoga.fusalg.area.ALinkArea;
	import net.kaikoga.fusalg.cellinfo.CellInfo;
	import net.kaikoga.fusalg.cellinfo.PalaceCellInfos;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.util.FusalgMath;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class APalaceArea extends ALinkArea {
		
		private var chipInfos:PalaceCellInfos;
		protected var context:PalaceAreaContext;
		
		public function APalaceArea(length:int, linktop:Boolean, linkbottom:Boolean, context:PalaceAreaContext) {
			this.chipInfos = PalaceCellInfos.getInstance();
			this.context = context || new PalaceAreaContext();
			super(length, linktop, linkbottom, this.chipInfos.sideSet);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			var i:int;
			var cell:Cell;
			if (context.nowLevel < 2) {
				var pillarcellinfo:CellInfo;
				switch (context.nowLevel) {
					case 0:
					pillarcellinfo = this.chipInfos.sideSet.top;
					break;
					case 1:
					pillarcellinfo = this.chipInfos.sideSet.bottom;
					break;
				}
				while (i < this.context.nowLeft) {
					Cell(row.cells[i++]).reset(pillarcellinfo);
				}
				while (i <= this.context.nowRight) {
					this.buildLinkCell(Cell(row.cells[i++]), this.chipInfos.groundSet, index);
				}
				while (i < Field.ROW_CELLS) {
					Cell(row.cells[i++]).reset(pillarcellinfo);
				}
			} else {
				for (i = 1; i < Field.ROW_CELLS; i++) {
					this.buildLinkCell(Cell(row.cells[i]), this.chipInfos.groundSet, index);
				}
			}
			if (context.nowLevel <= 0) {
				context.shuffle();
			} else {
				context.nowLevel--;
			}
			super.buildRow(field, row, index);
		}
		
	}
	
}
