﻿
package net.kaikoga.fusalg.area.area4 {
	
	import net.kaikoga.fusalg.area.AFieldArea;
	import net.kaikoga.fusalg.area.Areas;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.enemya.Jien;
	import net.kaikoga.fusalg.mortal.enemyc.InsectR;
	import net.kaikoga.fusalg.mortal.enemyd.TrentM;
	import net.kaikoga.fusalg.mortal.enemyd.TrentL;
	import net.kaikoga.fusalg.mortal.enemye.Zombie;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area4_1 extends AFieldArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_4_1_1"
			],
			waltz:[
				"waltz_4_1_1"
			],
			ghanae:[
				"ghanae_4_1_1"
			],
			silruy:[
				"silruy_4_1_1"
			]
		}
		
		public function Area4_1(field:Field) {
			super(16 - field.flags.getProceeding(10, 0, 12, 0) * 16);
			this.shrubRate = 0;
			this.bushRate = 0.1;
			this.rockRate = 0.2;
			this.areaText = " AREA 4-1";
			this.areaNameText = ' "PALACE" ';
			this.areaMessages = AREA_MESSAGES;
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch(index & 15) {
				case 1:
				field.addEnemy(new Jien());
				field.addEnemy(new InsectR());
				break;
				case 3:
				field.addEnemy(new TrentM());
				break;
				case 2:
				field.addEnemy(new Zombie());
				break;
			}
			if (index == 6) {
				field.addEnemy(new TrentL());
			}
		}
		
		override public function nextArea(field:Field):void {
			if (field.flags.timeIsBefore(14, 0)) {
				field.nextArea(new Area4_2(field));
			} else {
				field.nextArea(Areas.getTownEntry(field, 5));
			}
		}
	}
	
}
