﻿
package net.kaikoga.fusalg.area.area4 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.enemya.Jien;
	import net.kaikoga.fusalg.mortal.enemyd.TrentS;
	import net.kaikoga.fusalg.mortal.enemyd.TrentM;
	import net.kaikoga.fusalg.mortal.enemye.Zombie;
	import net.kaikoga.fusalg.mortal.enemye.Wight;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area4_2 extends APalaceArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_4_2_1"
			],
			waltz:[
				"waltz_4_2_1"
			],
			ghanae:[
				"ghanae_4_2_1"
			],
			silruy:[
				"silruy_4_2_1"
			]
		}
		
		public function Area4_2(field:Field) {
			super(48 - field.flags.getProceeding(10, 0, 14, 0) * 48, true, false, null);
			this.areaText = " AREA 4-2";
			this.areaNameText = ' "PALACE" ';
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music3);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch (index & 3) {
				case 0:
				field.addEnemy(new Zombie());
				field.addEnemy(new Jien());
				break;
				case 1:
				field.addEnemy(new TrentM());
				break;
				case 2:
				field.addEnemy(new Wight());
				break;
				case 3:
				field.addEnemy(new TrentS());
				break;
			}
		}
		
		override public function nextArea(field:Field):void {
			if (field.flags.timeIsBefore(14, 0)) {
				field.nextArea(new Area4_3(field, this.context));
			} else {
				field.nextArea(new Area4_Exit());
			}
		}
	}
	
}
