﻿
package net.kaikoga.fusalg.area.area4 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.boss.Golem;
	import net.kaikoga.fusalg.mortal.enemya.Jien;
	import net.kaikoga.fusalg.mortal.enemyd.TrentS;
	import net.kaikoga.fusalg.mortal.enemye.Zombie;
	import net.kaikoga.fusalg.mortal.npc.WizardNPC;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area4_3 extends APalaceArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_4_3_1"
			],
			waltz:[
				"waltz_4_3_1"
			],
			ghanae:[
				"ghanae_4_3_1"
			],
			silruy:[
				"silruy_4_3_1"
			]
		}
		
		private var boss:Golem;
		
		public function Area4_3(field:Field, context:PalaceAreaContext) {
			super(32, true, true, context);
			this.areaText = " AREA 4-3";
			this.areaNameText = ' "PALACE" ';
			this.targetName = "golem";
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function getBossLife():int {
			return this.boss ? this.boss.life : 0;
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch (index & 3) {
				case 1:
				field.addEnemy(new Jien());
				break;
				case 3:
				field.addEnemy(new Zombie());
				break;
				default:
				field.addEnemy(new TrentS());
				break;
			}
			if (this.boss.life <= 0) {
				this.nextArea(field);
			}
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			this.boss = new Golem()
			field.addEnemy(new WizardNPC("wiz4", this.boss));
		}
		
		override public function nextArea(field:Field):void {
			if (field.flags.timeIsBefore(9, 30)) {
				field.nextArea(new Area4_4(field, this.context));
			} else {
				field.nextArea(new Area4_4(field, this.context));
			}
		}
	}
	
}
