﻿
package net.kaikoga.fusalg.area.area4 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.enemya.Jien;
	import net.kaikoga.fusalg.mortal.enemyd.TrentM;
	import net.kaikoga.fusalg.mortal.enemye.Lich;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area4_4 extends APalaceArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_4_4_1"
			],
			waltz:[
				"waltz_4_4_1"
			],
			ghanae:[
				"ghanae_4_4_1"
			],
			silruy:[
				"silruy_4_4_1"
			]
		}
		
		public function Area4_4(field:Field, context:PalaceAreaContext) {
			super(32, true, true, context);
			this.areaText = " AREA 4-4";
			this.areaNameText = ' "PALACE" ';
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music3);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch (index & 3) {
				case 0:
				field.addEnemy(new TrentM());
				break;
				case 2:
				field.addEnemy(new Lich());
				break;
				default:
				field.addEnemy(new Jien());
				break;
			}
		}
		override public function nextArea(field:Field):void {
			field.nextArea(new Area4_Exit());
		}
	}
	
}
