﻿
package net.kaikoga.fusalg.area.area5 {
	
	import net.kaikoga.fusalg.area.ALinkArea;
	import net.kaikoga.fusalg.cellinfo.CellInfo;
	import net.kaikoga.fusalg.cellinfo.RemnantCellInfos;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.util.FusalgMath;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class ARemnantArea extends ALinkArea {
		
		protected var chipInfos:RemnantCellInfos;
		
		protected var context:RemnantAreaContext;
		
		public function ARemnantArea(length:int, linktop:Boolean, linkbottom:Boolean, context:RemnantAreaContext = null) {
			this.chipInfos = RemnantCellInfos.getInstance();
			this.context = context || new RemnantAreaContext();
			super(length, linktop, linkbottom, this.chipInfos.sideHSet);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			var i:int = 1;
			for (i = 1; i < Field.ROW_CELLS; i++) {
				this.buildLinkCell(Cell(row.cells[i]), this.chipInfos.groundSet1, index);
			}
			if ((Math.random() > 0.8) || (this.context.nowWall == -1)) {
				var oldwall:int = this.context.nowWall;
				this.context.nowWall = FusalgMath.randomInt(1, 9);
				var horizmin:int = oldwall < this.context.nowWall ? oldwall : this.context.nowWall;
				var horizmax:int = oldwall > this.context.nowWall ? oldwall : this.context.nowWall;
				horizmin = FusalgMath.randomInt(1, (horizmin < 0) ? 9 : horizmin);
				horizmax = FusalgMath.randomInt(horizmax, 9);
				for (i = horizmin; i <= horizmax; i++) {
					var wallcellinfo:CellInfo;
					switch (i) {
						case oldwall:
						wallcellinfo = this.chipInfos.wallSet.top;
						break;
						case this.context.nowWall:
						wallcellinfo = this.chipInfos.wallSet.bottom;
						break;
						default:
						wallcellinfo = this.chipInfos.wallSet.horiz;
						break;
					}
					this.buildCell(row.cells[i], wallcellinfo);
					Cell(row.cells[i]).reset(wallcellinfo);
				}
			} else if (this.context.nowWall > 0) {
				this.buildLinkCell(row.cells[this.context.nowWall], this.chipInfos.wallSet, index);
			}
			this.context.nextRow(0.5, 6);
			for (i = 0; i < this.context.nowLeft; i++) {
				this.buildCell(row.cells[i], this.chipInfos.sideHSet.vert);
			}
			this.buildCell(row.cells[this.context.nowLeft], this.chipInfos.sideHSet.bottom);
			this.buildCell(row.cells[this.context.nowRight], this.chipInfos.sideHSet.top);
			for (i = this.context.nowRight+1; i < Field.ROW_CELLS; i++) {
				this.buildCell(row.cells[i], this.chipInfos.sideHSet.vert);
			}
			
		}
		
	}
	
}
