﻿
package net.kaikoga.fusalg.area.area5 {
	
	import net.kaikoga.fusalg.area.AFieldArea;
	import net.kaikoga.fusalg.area.Areas;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.enemya.Kitaa;
	import net.kaikoga.fusalg.mortal.enemyc.InsectR;
	import net.kaikoga.fusalg.mortal.enemyd.TrentM;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area5_1 extends AFieldArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_5_1_1"
			],
			waltz:[
				"waltz_5_1_1"
			],
			ghanae:[
				"ghanae_5_1_1"
			],
			silruy:[
				"silruy_5_1_1"
			]
		}
		
		public function Area5_1(field:Field) {
			super(16 - field.flags.getProceeding(12, 0, 14, 0) * 16);
			this.shrubRate = 0.2;
			this.bushRate = 0.15;
			this.rockRate = 0.1;
			this.areaText = " AREA 5-1";
			this.areaNameText = ' "REMNANT"';
			this.areaMessages = AREA_MESSAGES;
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch (index & 3) {
				case 0:
				field.addEnemy(new Kitaa());
				field.addEnemy(new InsectR());
				break;
				case 1:
				case 3:
				field.addEnemy(new TrentM());
				break;
			}
		}
		
		override public function nextArea(field:Field):void {
			if (field.flags.timeIsBefore(14, 30)) {
				field.nextArea(new Area5_2(field));
			} else {
				field.nextArea(Areas.getTownEntry(field, 6));
			}
		}
	}
	
}
