﻿
package net.kaikoga.fusalg.area.area5 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.cellinfo.CellInfo;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.enemya.Kitaa;
	import net.kaikoga.fusalg.mortal.enemyb.GhostS;
	import net.kaikoga.fusalg.mortal.enemyb.GhostM;
	import net.kaikoga.fusalg.mortal.enemyb.GhostL;
	import net.kaikoga.fusalg.mortal.enemyc.InsectR;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area5_2 extends ARemnantArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_5_2_1"
			],
			waltz:[
				"waltz_5_2_1"
			],
			ghanae:[
				"ghanae_5_2_1"
			],
			silruy:[
				"silruy_5_2_1"
			]
		}
		
		public function Area5_2(field:Field) {
			super(48 - field.flags.getProceeding(12, 0, 15, 0) * 48, true, false);
			this.areaText = " AREA 5-2";
			this.areaNameText = ' "REMNANT"';
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music2);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch (index & 3) {
				case 0:
				field.addEnemy(new Kitaa());
				break;
				case 1:
				field.addEnemy(new GhostS());
				break;
				case 2:
				field.addEnemy(new GhostL());
				field.addEnemy(new InsectR());
				break;
				case 3:
				field.addEnemy(new GhostM());
				break;
			}
		}
		
		override public function nextArea(field:Field):void {
			if (field.flags.timeIsBefore(15, 0)) {
				field.nextArea(new Area5_3(field, this.context));
			} else {
				field.nextArea(new Area5_Exit());
			}
		}
	}
	
}
