﻿
package net.kaikoga.fusalg.area.area5 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.cellinfo.CellInfo;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.boss.Wurm;
	import net.kaikoga.fusalg.mortal.enemya.Kitaa;
	import net.kaikoga.fusalg.mortal.enemyb.GhostL;
	import net.kaikoga.fusalg.mortal.npc.SilruyNPC;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area5_3 extends ARemnantArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_5_3_1"
			],
			waltz:[
				"waltz_5_3_1"
			],
			ghanae:[
				"ghanae_5_3_1"
			],
			silruy:[
				"silruy_5_3_1"
			]
		}
		
		private var boss:Wurm;
		private var npc:SilruyNPC;
		
		public function Area5_3(field:Field, context:RemnantAreaContext) {
			super(32, true, true, context);
			this.areaText = " AREA 5-3";
			this.areaNameText = ' "REMNANT"';
			this.targetName = "wurm";
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function getBossLife():int {
			return this.boss ? this.boss.life : 0;
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			if (index == 31) {
				this.buildCell(row.cells[5], this.chipInfos.groundSet1.vert);
				this.boss = new Wurm();
				field.addEnemy(new SilruyNPC("sil5", this.boss), 160);
			}
			switch (index & 3) {
				case 0:
				field.addEnemy(new Kitaa());
				break;
				case 2:
				field.addEnemy(new GhostL());
				break;
			}
			if (this.boss.life <= 0) {
				field.flags.wurmLiving = false;
				this.nextArea(field);
			}
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
		}
		
		override public function nextArea(field:Field):void {
			if (field.flags.timeIsBefore(14, 0)) {
				field.nextArea(new Area5_4(field, this.context));
			} else {
				field.nextArea(new Area5_Exit());
			}
		}
		
	}
	
}
