﻿
package net.kaikoga.fusalg.area.area5 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.cellinfo.CellInfo;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.enemyb.GhostS;
	import net.kaikoga.fusalg.mortal.enemyb.GhostM;
	import net.kaikoga.fusalg.mortal.enemyb.GhostL;
	import net.kaikoga.fusalg.mortal.enemye.Wight;
	import net.kaikoga.fusalg.mortal.enemye.Lich;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area5_4 extends ARemnantArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_5_4_1"
			],
			waltz:[
				"waltz_5_4_1"
			],
			ghanae:[
				"ghanae_5_4_1"
			],
			silruy:[
				"silruy_5_4_1"
			]
		}
		
		public function Area5_4(field:Field, context:RemnantAreaContext) {
			super(32, true, true, context);
			this.areaText = " AREA 5-4";
			this.areaNameText = ' "REMNANT"';
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music2);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch (index & 3) {
				case 0:
				field.addEnemy(new Wight());
				field.addEnemy(new GhostS());
				break;
				case 1:
				field.addEnemy(new GhostL());
				field.addEnemy(new GhostS());
				break;
				case 2:
				field.addEnemy(new Wight());
				field.addEnemy(new GhostM());
				break;
				case 3:
				field.addEnemy(new Lich());
				field.addEnemy(new GhostM());
				break;
			}
		}
		
		override public function nextArea(field:Field):void {
			field.nextArea(new Area5_Exit());
		}
		
	}
	
}
