﻿
package net.kaikoga.fusalg.area.area6 {
	
	import net.kaikoga.fusalg.area.ALinkArea;
	import net.kaikoga.fusalg.cellinfo.FortressCellInfos;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.util.FusalgMath;
	import net.kaikoga.fusalg.util.QuotientSwitch;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class AFortressArea extends ALinkArea {
		
		private var chipInfos:FortressCellInfos;
		protected var fenceRate:Number = 0.1;
		protected var barricadeRate:Number = 0.1;
		
		public function AFortressArea(length:int, linktop:Boolean, linkbottom:Boolean) {
			this.chipInfos = FortressCellInfos.getInstance();
			super(length, linktop, linkbottom, this.chipInfos.sideSet);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			var i:int;
			var cell:Cell;
			var space:int = FusalgMath.randomInt(2, 8);
			switch(space) {
				case 2:
				space = 1;
				break;
				case 8:
				space = 9;
				break;
			}
			var qs:QuotientSwitch = QuotientSwitch.qs();
			if (qs.rate(this.fenceRate)) {
				for (i = 1; i < Field.ROW_CELLS; i++) {
					switch (i) {
						case space:
						this.buildLinkCell(Cell(row.cells[i]), this.chipInfos.groundSet, index);
						break;
						case space - 1:
						this.buildCell(Cell(row.cells[i]), this.chipInfos.fenceHSet.bottom, index);
						break;
						case space + 1:
						this.buildCell(Cell(row.cells[i]), this.chipInfos.fenceHSet.top, index);
						break;
						default:
						this.buildCell(Cell(row.cells[i]), this.chipInfos.fenceHSet.vert, index);
						break;
					}
				}
			} else if (qs.rate(this.barricadeRate)) {
				for (i = 1; i < Field.ROW_CELLS; i++) {
					switch (i) {
						case space:
						this.buildLinkCell(Cell(row.cells[i]), this.chipInfos.groundSet, index);
						break;
						case space - 1:
						this.buildCell(Cell(row.cells[i]), this.chipInfos.barricadeHSet.bottom, index);
						break;
						case space + 1:
						this.buildCell(Cell(row.cells[i]), this.chipInfos.barricadeHSet.top, index);
						break;
						default:
						this.buildCell(Cell(row.cells[i]), this.chipInfos.barricadeHSet.vert, index);
						break;
					}
				}
			} else {
				for (i = 1; i < Field.ROW_CELLS; i++) {
					this.buildLinkCell(Cell(row.cells[i]), this.chipInfos.groundSet, index);
				}
			}
			super.buildRow(field, row, index);
		}
		
	}
	
}
