﻿
package net.kaikoga.fusalg.area.area6 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.enemya.Kitaa;
	import net.kaikoga.fusalg.mortal.enemyb.GhostM;
	import net.kaikoga.fusalg.mortal.enemyb.GhostL;
	import net.kaikoga.fusalg.mortal.enemyc.InsectR;
	import net.kaikoga.fusalg.mortal.enemyd.TrentL;
	import net.kaikoga.fusalg.mortal.enemyd.TrentM;
	import net.kaikoga.fusalg.mortal.enemyf.AxeRogue;
	import net.kaikoga.fusalg.mortal.enemyf.SwordRogue;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area6_1 extends AFortressArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_6_1_1"
			],
			waltz:[
				"waltz_6_1_1"
			],
			ghanae:[
				"ghanae_6_1_1"
			],
			silruy:[
				"silruy_6_1_1"
			]
		}
		
		public function Area6_1(field:Field) {
			super(96 - field.flags.getProceeding(12, 0, 15, 0) * 96, true, true);
			this.barricadeRate = 0.05;
			this.fenceRate = 0.1;
			this.areaText = " AREA 6-1";
			this.areaNameText = '"FORTRESS"';
			this.targetName = "wizard";
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music1);
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			this.barricadeRate += 0.002;
			switch (index & 15) {
				case 0:
				field.addEnemy(new InsectR());
				break;
				case 2:
				case 6:
				field.addEnemy(new GhostM());
				break;
				case 4:
				field.addEnemy(new GhostL());
				break;
				case 8:
				field.addEnemy(new TrentL());
				break;
				case 5:
				case 11:
				field.addEnemy(new TrentM());
				break;
				case 12:
				field.addEnemy(new AxeRogue(false));
				break;
				case 10:
				field.addEnemy(new AxeRogue(false));
				break;
				case 14:
				field.addEnemy(new SwordRogue(false));
				break;
				default:
				field.addEnemy(new Kitaa());
				break;
			}
		}
		
		override public function nextArea(field:Field):void {
			field.nextArea(new Area6_2(field));
		}
		
	}
	
}
