﻿
package net.kaikoga.fusalg.area.area6 {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.boss.Wizard;
	import net.kaikoga.fusalg.mortal.enemya.Kitaa;
	import net.kaikoga.fusalg.mortal.enemyb.GhostS;
	import net.kaikoga.fusalg.mortal.enemye.Zombie;
	import net.kaikoga.fusalg.strings.FusalgStrings;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area6_2 extends AFortressArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_6_2_1"
			],
			waltz:[
				"waltz_6_2_1"
			],
			ghanae:[
				"ghanae_6_2_1"
			],
			silruy:[
				"silruy_6_2_1"
			]
		}
		
		private var boss:Wizard;
		
		public function Area6_2(field:Field) {
			super(32, true, true);
			this.areaText = " AREA 6-2";
			this.areaNameText = '"FORTRESS"';
			this.targetName = "wizard";
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function getBossLife():int {
			return this.boss ? this.boss.life : 0;
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			switch (index & 3) {
				case 0:
				field.addEnemy(new Kitaa());
				break;
				case 2:
				field.addEnemy(new Zombie());
				break;
				default:
				field.addEnemy(new GhostS());
				break;
			}
			if (this.boss.life <= 0) {
				this.nextArea(field);
			}
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			this.boss = new Wizard();
			field.addEnemy(this.boss);
			field.messageLayer.message(field, FusalgStrings.getString("area6_2"));
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music4);
		}

		override public function nextArea(field:Field):void {
			if (field.flags.timeIsBefore(16, 0)) {
				field.nextArea(new Area6_3(field));
			} else {
				field.nextArea(new Area6_Exit());
			}
		}
		
	}
	
}
