﻿
package net.kaikoga.fusalg.area.area6 {
	
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.allystub.SilruyStub;
	import net.kaikoga.fusalg.mortal.enemya.Kitaa;
	import net.kaikoga.fusalg.mortal.boss.Hydra;
	import net.kaikoga.fusalg.strings.FusalgStrings;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area6_3 extends AFortressArea {
		
		private static const AREA_MESSAGES:Object/*Array*/ = {
			amira:[
				"amira_6_3_1"
			],
			waltz:[
				"waltz_6_3_1"
			],
			ghanae:[
				"ghanae_6_3_1"
			],
			silruy:[
				"silruy_6_3_1"
			]
		}
		
		private var boss:Hydra;
		
		public function Area6_3(field:Field) {
			super(32, true, true);
			this.areaText = " AREA 6-3";
			this.areaNameText = '"FORTRESS"';
			this.areaMessages = AREA_MESSAGES;
		}
		
		override public function getBossLife():int {
			return this.boss ? this.boss.life : 0;
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			super.buildRow(field, row, index);
			if (index > 20) {
				switch (index & 3) {
					case 0:
					field.addEnemy(new Kitaa());
					break;
				}
			}
			if (index == 16) {
				if (!this.boss) {
					this.targetName = "hydra";
					this.boss = new Hydra();
					field.addEnemy(this.boss);
					this.barricadeRate = 0.5;
					this.fenceRate = 0.5;
				}
			}
			if (this.boss && this.boss.life <= 0) {
				field.flags.hydraLiving = false;
				this.nextArea(field);
			}
		}
	
		override public function onEnterSelf(field:Field):void {
			field.addEnemy(new SilruyStub());
			field.messageLayer.message(field, FusalgStrings.getString("area6_3"));
		}
		
		override public function nextArea(field:Field):void {
			field.nextArea(new Area6_Exit());
		}
		
	}
	
}
