﻿
package net.kaikoga.fusalg.area.area6 {
	
	import net.kaikoga.fusalg.area.AArea;
	import net.kaikoga.fusalg.area.Areas;
	import net.kaikoga.fusalg.cellinfo.FortressCellInfos;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.ally.Amira;
	import net.kaikoga.fusalg.mortal.ally.Ghanae;
	import net.kaikoga.fusalg.mortal.ally.Silruy;
	import net.kaikoga.fusalg.mortal.ally.Waltz;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Area6_Exit extends AArea {
		
		private var chipInfos:FortressCellInfos;

		public function Area6_Exit() {
			super(1);
			this.chipInfos = FortressCellInfos.getInstance();
		}

		override protected function buildRow(field:Field, row:Row, index:int):void {
			for (var i:int = 1; i < Field.ROW_CELLS; i++) {
				Cell(row.cells[i]).reset(this.chipInfos.groundSet.top);
			}
			row.resetSideChip(this.chipInfos.sideSet.top);
		}
		
		override public function nextArea(field:Field):void {
			if (field.flags.hydraLiving && !field.flags.wurmLiving) {
				field.endingLayer.endType = "end6";
			} else {
				if (field.heroine is Amira) {
					field.endingLayer.endType = "end1";
				} else if (field.heroine is Waltz) {
					field.endingLayer.endType = "end2";
				} else if (field.heroine is Ghanae) {
					field.endingLayer.endType = "end3";
				} else if (field.heroine is Silruy) {
					field.endingLayer.endType = "end4";
				}
			}
			field.enableLayer(field.endingLayer);
		}
		
	}
	
}
