﻿
package net.kaikoga.fusalg.area.town {
	
	import net.kaikoga.fusalg.area.AArea;
	import net.kaikoga.fusalg.area.Areas;
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.cellinfo.TownCellInfos;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.mortal.ally.Amira;
	import net.kaikoga.fusalg.mortal.ally.Waltz;
	import net.kaikoga.fusalg.mortal.allystub.AmiraStub;
	import net.kaikoga.fusalg.mortal.allystub.WaltzStub;
	import net.kaikoga.fusalg.mortal.AMortal;
	import net.kaikoga.fusalg.mortal.npc.ShopNPC;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class AreaTown_1 extends AArea {
		
		private var nowStage:int;
		private var chipInfos:TownCellInfos;

		private var chipInfoRefs:Array = [
		["stop", "ggrs", "ggrs", "ggrs", "ggrs", "ggrs", "ggrs", "ggrs", "ggrs", "ggrs", "stop"],
		["svrt", "ggrs", "ggrs", "ggrs", "ggrs", "gstn", "ggrs", "ggrs", "ggrs", "ggrs", "svrt"],
		["svrt", "ggrs", "ggrs", "ggrs", "ggrs", "gstn", "ggrs", "ggrs", "ggrs", "ggrs", "svrt"],
		["svrt", "btop", "bhrz", "btop", "ggrs", "gstn", "ggrs", "btop", "bhrz", "btop", "svrt"],
		["svrt", "bvrt", "gwod", "bbtm", "ggrs", "gstn", "ggrs", "bbtm", "gwod", "bvrt", "svrt"],
		["svrt", "bvrt", "gwod", "bcnt", "ACCS", "gstn", "MSCT", "bcnt", "gwod", "bvrt", "svrt"],
		["svrt", "bvrt", "gwod", "btop", "ggrs", "gstn", "ggrs", "btop", "gwod", "bvrt", "svrt"],
		["svrt", "bbtm", "bhrz", "bbtm", "ggrs", "gstn", "ggrs", "bbtm", "bhrz", "bbtm", "svrt"],
		["svrt", "ggrs", "ggrs", "ggrs", "gstn", "gstn", "gstn", "ggrs", "ggrs", "ggrs", "svrt"],
		["svrt", "btop", "bhrz", "btop", "gstn", "ggrs", "gstn", "btop", "bhrz", "btop", "svrt"],
		["svrt", "bvrt", "gwod", "bbtm", "gstn", "ggrs", "gstn", "bbtm", "gwod", "bvrt", "svrt"],
		["svrt", "bvrt", "gwod", "bcnt", "WEPN", "ggrs", "ARMR", "bcnt", "gwod", "bvrt", "svrt"],
		["svrt", "bvrt", "gwod", "btop", "gstn", "ggrs", "gstn", "btop", "gwod", "bvrt", "svrt"],
		["svrt", "bbtm", "owpn", "bbtm", "gstn", "ggrs", "gstn", "bbtm", "oarm", "bbtm", "svrt"],
		["svrt", "ggrs", "ggrs", "gstn", "gstn", "gstn", "gstn", "gstn", "ggrs", "ggrs", "svrt"],
		["sbtm", "ggrs", "ggrs", "ggrs", "gstn", "gstn", "gstn", "ggrs", "ggrs", "ggrs", "sbtm"]
		];
		
		public function AreaTown_1(nowstage:int) {
			super(16);
			this.nowStage = nowstage;
			this.chipInfos = TownCellInfos.getInstance();
			this.areaText = " AREA  -1";
			this.areaNameText = ' ZEROFRAME';
		}
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			for (var i:int = 0; i < Field.ROW_CELLS; i++) {
				var cell:Cell = Cell(row.cells[i]);
				cell.reset(this.chipInfos[this.chipInfoRefs[index][i]]);
			}
			switch (index) {
				case 1:
				if (field.flags.amira && !(field.heroine is Amira)) {
					field.addEnemy(new AmiraStub(), 64);
				}
				if (field.flags.waltz && !(field.heroine is Waltz)) {
					field.addEnemy(new WaltzStub(), 256);
				}
				break;
				case 5:
				case 11:
				field.addEnemy(new ShopNPC(AMortal.DIR_RIGHT, "shopnpc"), 64);
				field.addEnemy(new ShopNPC(AMortal.DIR_RIGHT, "shopnpc"), 256);
				break;
			}
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			field.audioPlayer.trySwapAudio(Sounds.getInstance().music0);
		}
		
		override public function nextArea(field:Field):void {
			field.nextArea(Areas.getStageEntry(field, this.nowStage));
		}
		
	}
	
}
