﻿
package net.kaikoga.fusalg.area.town {
	
	import net.kaikoga.fusalg.area.AArea;
	import net.kaikoga.fusalg.area.Areas;
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.cellinfo.TownCellInfos;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.field.Row;
	import net.kaikoga.fusalg.mortal.ally.Amira;
	import net.kaikoga.fusalg.mortal.ally.Ghanae;
	import net.kaikoga.fusalg.mortal.ally.Waltz;
	import net.kaikoga.fusalg.mortal.allystub.AmiraStub;
	import net.kaikoga.fusalg.mortal.allystub.GhanaeStub;
	import net.kaikoga.fusalg.mortal.allystub.WaltzStub;
	import net.kaikoga.fusalg.mortal.AMortal;
	import net.kaikoga.fusalg.mortal.npc.MessengerNPC;
	import net.kaikoga.fusalg.mortal.npc.ShopNPC;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class AreaTown_2 extends AArea {
		
		private var nowStage:int;
		private var chipInfos:TownCellInfos;

		private var chipInfoRefs:Array = [
		["btop", "bhrz", "btop", "ggrs", "ggrs", "btop", "ggrs", "ggrs", "btop", "bhrz", "btop"],
		["bvrt", "gwod", "bbtm", "gcpt", "gcpt", "bbtm", "gcpt", "gcpt", "bbtm", "gwod", "bvrt"],
		["bvrt", "gwod", "gwod", "gstn", "gstn", "gstn", "gstn", "gstn", "gwod", "gwod", "bvrt"],
		["bvrt", "gwod", "gwod", "gstn", "ggrs", "ggrs", "ggrs", "gstn", "gwod", "gwod", "bvrt"],
		["bvrt", "gwod", "ACCS", "gstn", "gstn", "gstn", "gstn", "gstn", "MSCT", "gwod", "bvrt"],
		["btop", "bhrz", "bcnt", "btop", "gwod", "gwod", "gwod", "btop", "bcnt", "bhrz", "btop"],
		["bvrt", "gwod", "gwod", "bvrt", "gwod", "gwod", "gwod", "bvrt", "gwod", "gwod", "bvrt"],
		["bvrt", "gwod", "gwod", "bvrt", "gwod", "gwod", "gwod", "bvrt", "gwod", "gwod", "bvrt"],
		["btop", "bhrz", "bhrz", "bbtm", "gwod", "gwod", "gwod", "bbtm", "bhrz", "bhrz", "btop"],
		["bvrt", "gwod", "gwod", "gwod", "gwod", "gwod", "gwod", "gwod", "gwod", "gwod", "bvrt"],
		["bvrt", "gwod", "gwod", "gwod", "gwod", "gwod", "gwod", "gwod", "gwod", "gwod", "bvrt"],
		["bvrt", "WEPN", "gwod", "gwod", "gwod", "gwod", "gwod", "gwod", "gwod", "ARMR", "bvrt"],
		["btop", "bcnt", "bhrz", "btop", "gcpt", "gcpt", "gcpt", "btop", "bhrz", "bcnt", "btop"],
		["bvrt", "gwod", "gwod", "bvrt", "gstn", "gstn", "gstn", "bvrt", "gwod", "gwod", "bvrt"],
		["bvrt", "gwod", "gwod", "bvrt", "gstn", "gstn", "gstn", "bvrt", "gwod", "gwod", "bvrt"],
		["bbtm", "bhrz", "bhrz", "owpn", "ggrs", "ggrs", "ggrs", "oarm", "bhrz", "bhrz", "bbtm"]
		];
		
		public function AreaTown_2(nowstage:int) {
			super(16);
			this.nowStage = nowstage;
			this.chipInfos = TownCellInfos.getInstance();
			this.areaText = " AREA  -2";
			this.areaNameText = ' NEETLAND';
		}
		
		private static const MESSENGER_MESSAGES:Array/*String*/= [null, "msg1", "msg2", "msg3", "msg4", "msg5", "msg6", "msg7"];
		
		override protected function buildRow(field:Field, row:Row, index:int):void {
			for (var i:int = 0; i < Field.ROW_CELLS; i++) {
				var cell:Cell = Cell(row.cells[i]);
				cell.reset(this.chipInfos[this.chipInfoRefs[index][i]]);
			}
			switch (index) {
				case 2:
				if (field.flags.amira && !(field.heroine is Amira)) {
					field.addEnemy(new AmiraStub(), 64);
				}
				if (field.flags.waltz && !(field.heroine is Waltz)) {
					field.addEnemy(new WaltzStub(), 256);
				}
				if (field.flags.ghanae && !(field.heroine is Ghanae)) {
					field.addEnemy(new GhanaeStub(), 160);
				}
				break;
				case 10:
				field.addEnemy(new MessengerNPC(MESSENGER_MESSAGES[this.nowStage]), 160);
				break;
				case 6:
				field.addEnemy(new ShopNPC(AMortal.DIR_UP, "shopnpc"), 64);
				field.addEnemy(new ShopNPC(AMortal.DIR_UP, "shopnpc"), 256);
				break;
				case 13:
				field.addEnemy(new ShopNPC(AMortal.DIR_DOWN, "shopnpc"), 32);
				field.addEnemy(new ShopNPC(AMortal.DIR_DOWN, "shopnpc"), 288);
				break;
			}
		}
		
		override public function onEnterSelf(field:Field):void {
			super.onEnterSelf(field);
			if (this.nowStage < 7) {
				field.audioPlayer.trySwapAudio(Sounds.getInstance().music0);
			}
		}
		
		override public function nextArea(field:Field):void {
			field.nextArea(Areas.getStageEntry(field, this.nowStage));
		}
	}
	
}
