﻿
package net.kaikoga.fusalg.audio {
	
	import flash.events.Event;
	import flash.media.SoundChannel;
	import net.kaikoga.fusalg.debug.EDebug;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class AudioPlayer {
		
		private var channelMap:Object/*SoundChannel*/;
		private var audioDataMap:Object/*AudioData*/;
		
		public function AudioPlayer() {
			super();
			this.channelMap = { };
			this.audioDataMap = { };
		}
		
		public function stopChannel(channel:String):void {
			if (EDebug.TRACE_AUDIO) {
				trace("AudioPlayer.stopChannel(): ", channel);
			}
			var nowChannel:SoundChannel = this.channelMap[channel];
			if (nowChannel) {
				nowChannel.stop();
			}
			delete this.channelMap[channel];
			delete this.audioDataMap[channel];
		}
		
		public function stopAll():void {
			for each (var ch:SoundChannel in this.channelMap) {
				ch.stop();
			}
			this.channelMap = { };
			this.audioDataMap = { };
		}
		
		public function tryPreemptAudio(audio:AudioData):void {
			if (EDebug.TRACE_AUDIO) {
				trace("AudioPlayer.tryPreemptAudio(): ", audio);
			}
			if (audio != null) {
				var oldchannel:SoundChannel = this.channelMap[audio.channel];
				if (oldchannel) {
					var oldpos:Number = oldchannel.position;
					oldchannel.stop();
				}
				this.channelMap[audio.channel] = audio.startSound();
				var _this:AudioPlayer = this;
				this.channelMap[audio.channel].addEventListener(Event.SOUND_COMPLETE, function(evt:Event):void {
					if (oldchannel) {
						var oldaudio:AudioData = _this.audioDataMap[audio.channel];
						if (oldaudio) {
							 _this.channelMap[audio.channel] = oldaudio.startSound(oldpos);
						}
					}
				});
			}
		}
		
		public function tryStartAudio(audio:AudioData):void {
			if (EDebug.TRACE_AUDIO) {
				trace("AudioPlayer.tryPlayAudio(): ", audio);
			}
			if (audio != null) {
				var oldchannel:SoundChannel = this.channelMap[audio.channel];
				if (oldchannel) {
					if (audio.willOverride) {
						oldchannel.stop();
					} else {
						return;
					}
				}
				this.channelMap[audio.channel] = audio.startSound();
				this.audioDataMap[audio.channel] = audio;
			}
		}
		
		public function trySwapAudio(audio:AudioData):void {
			if (audio != null) {
				var nowAudioData:AudioData = this.audioDataMap[audio.channel];
				if (nowAudioData != audio) {
					this.tryStartAudio(audio);
				}
			}
		}
		
	}
	
}
