﻿
package net.kaikoga.fusalg.cellevent {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.ally.Amira;
	import net.kaikoga.fusalg.strings.FusalgStrings;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class AccesoryShopCellEvent extends ACellEvent {
		
		private var zCost:int;
		private var xCost:int;
		private var cCost:int;
		
		private var amira:Amira;
		
		public function AccesoryShopCellEvent() {
			super();
			
		}
		
		private function calcCost(field:Field, premessage:String):void {
			this.amira = field.flags.amira;
			if (this.amira) {
				var lv:int = this.amira.level;
				var atlv:int = this.amira.attackLevel;
				var aulv:int = this.amira.auraLevel;
				this.zCost = lv * 100;
				this.xCost = (atlv > 8) ? 0 : atlv * 200;
				this.cCost = (aulv > 8) ? 0 : aulv * 200;
			} else {
				this.zCost = 0;
				this.xCost = 0;
				this.cCost = 0;
			}
			var param:Array = [premessage, this.zCost || "-", this.xCost || "-", this.cCost || "-"];
			field.messageLayer.flush();
			field.messageLayer.message(field, FusalgStrings.getString("accesory_cost", param));
		}
		
		override public function onEnter(field:Field):void {
			this.calcCost(field, FusalgStrings.getString("accesory_enter"));
		}
		
		override public function onExit(field:Field):void {
			field.messageLayer.flush();
		}
		
		override protected function onInput(field:Field, input:String):void {
			field.messageLayer.flush();
			var cost:int = 1;
			switch (input) {
				case "z":
				cost = this.zCost;
				if (cost == 0) {
					field.messageLayer.message(field, FusalgStrings.getString("accesory_z_out", [cost]));
				} else if (field.flags.pay(cost)) {
					this.amira.level++;
					this.calcCost(field, FusalgStrings.getString("accesory_z_ok", [cost]));
				} else {
					field.messageLayer.message(field, FusalgStrings.getString("accesory_z_ng", [cost]));
				}
				break;
				case "x":
				cost = this.xCost;
				if (cost == 0) {
					field.messageLayer.message(field, FusalgStrings.getString("accesory_x_out", [cost]));
				} else if (field.flags.pay(cost)) {
					this.amira.attackLevel++;
					this.calcCost(field, FusalgStrings.getString("accesory_x_ok", [cost]));
				} else {
					field.messageLayer.message(field, FusalgStrings.getString("accesory_x_ng", [cost]));
				}
				break;
				case "c":
				cost = this.cCost;
				if (cost == 0) {
					field.messageLayer.message(field, FusalgStrings.getString("accesory_c_out", [cost]));
				} else if (field.flags.pay(cost)) {
					this.amira.auraLevel++;
					this.calcCost(field, FusalgStrings.getString("accesory_c_ok", [cost]));
				} else {
					field.messageLayer.message(field, FusalgStrings.getString("accesory_c_ng", [cost]));
				}
				break;
			}
		}
		
	}
	
}
