﻿
package net.kaikoga.fusalg.cellevent {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.strings.FusalgStrings;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class ArmorShopCellEvent extends ACellEvent {
		
		public function ArmorShopCellEvent() {
			super();
			
		}
		
		private function showCost(field:Field, preMessage:String):void {
			var c:int = field.avatar.shieldLevel * (field.avatar.shieldLevel + 1) * 50;
			field.messageLayer.flush();
			field.messageLayer.message(field, FusalgStrings.getString("armor_cost", [preMessage, c]));
		}
		
		override public function onEnter(field:Field):void {
			this.showCost(field, FusalgStrings.getString("armor_enter"));
		}
		
		override public function onExit(field:Field):void {
			field.messageLayer.flush();
		}
		
		override protected function onInput(field:Field, input:String):void {
			var cost:int = field.avatar.shieldLevel * field.avatar.shieldLevel * 100;
			switch (input) {
				case "c":
				if (field.flags.pay(cost)) {
					field.avatar.shieldLevel++;
					this.showCost(field, FusalgStrings.getString("armor_c_ok", [cost]));
				} else {
					this.showCost(field, FusalgStrings.getString("armor_c_ng", [cost]));
				}
				break;
			}
		}
		
	}
	
}
