﻿
package net.kaikoga.fusalg.cellevent {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.strings.FusalgStrings;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class WeaponShopCellEvent extends ACellEvent {
		
		public function WeaponShopCellEvent() {
			super();
		}
		
		private function showCost(field:Field, preMessage:String):void {
			var a:int = field.avatar.swordLevel * (field.avatar.swordLevel + 1) * 50;
			var b:int = field.avatar.axeLevel * (field.avatar.axeLevel + 1) * 50;
			field.messageLayer.flush();
			field.messageLayer.message(field, FusalgStrings.getString("weapon_cost", [preMessage, a, b]));
		}
		
		override public function onEnter(field:Field):void {
			this.showCost(field, FusalgStrings.getString("weapon_enter"));
		}
		
		override public function onExit(field:Field):void {
			field.messageLayer.flush();
		}
		
		override protected function onInput(field:Field, input:String):void {
			var cost:int;
			switch (input) {
				case "z":
				cost = field.avatar.swordLevel * field.avatar.swordLevel * 100;
				if (field.flags.pay(cost)) {
					field.avatar.swordLevel++;
					this.showCost(field, FusalgStrings.getString("weapon_z_ok", [cost]));
				} else {
					this.showCost(field, FusalgStrings.getString("weapon_z_ng", [cost]));
				}
				break;
				case "x":
				cost = field.avatar.axeLevel * field.avatar.axeLevel * 100;
				if (field.flags.pay(cost)) {
					field.avatar.axeLevel++;
					this.showCost(field, FusalgStrings.getString("weapon_x_ok", [cost]));
				} else {
					this.showCost(field, FusalgStrings.getString("weapon_x_ng", [cost]));
				}
				break;
			}
		}
		
	}
	
}
