﻿
package net.kaikoga.fusalg.cellinfo {
	
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class AvenueCellInfos {
		
		public var groundSet1:CellInfoSet;
		public var groundSet2:CellInfoSet;
		public var groundSet3:CellInfoSet;
		public var grass1:CellInfo;
		public var grass2:CellInfo;
		public var grass3:CellInfo;
		
		public var bush:CellInfo;
		public var rock:CellInfo;
		
		public var lsideSet:CellInfoSet;
		public var rsideSet:CellInfoSet;

		public function AvenueCellInfos() {
			super();
			var chipset:DotchipChipSet = Chips.getInstance().avenueChipM;
			
			this.groundSet1 = CellInfoSet.createById(chipset, 0, 8, 16, null, true);
			this.groundSet2 = CellInfoSet.createById(chipset, 1, 9, 17, null, true);
			this.groundSet3 = CellInfoSet.createById(chipset, 2, 10, 18, null, true);
			
			this.grass1 = CellInfo.createById(chipset, 3, true);
			this.grass2 = CellInfo.createById(chipset, 4, true);
			this.grass3 = CellInfo.createById(chipset, 5, true);
			this.bush = CellInfo.createChain(chipset, [11, 12, 13]);
			this.rock = CellInfo.createChain(chipset, [19, 20, 21]);
			this.lsideSet = CellInfoSet.createById(chipset, 6, 14, 22, null, false);
			this.rsideSet = CellInfoSet.createById(chipset, 7, 15, 23, null, false);
		}
		
		private static var instance:AvenueCellInfos;
		
		public static function getInstance():AvenueCellInfos {
			if (!instance) {
				instance = new AvenueCellInfos();
			}
			return instance;
		}
		
	}
	
}
