﻿
package net.kaikoga.fusalg.cellinfo {
	
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class CaveCellInfos {
		
		public var groundSet1:CellInfoSet;
		public var groundSet2:CellInfoSet;
		public var groundSet3:CellInfoSet;
		public var boulder:CellInfo;
		public var boulderL:CellInfo;
		public var sideSet:CellInfoSet;

		public function CaveCellInfos() {
			super();
			var chipset:DotchipChipSet = Chips.getInstance().caveChipM;
			
			this.groundSet1 = CellInfoSet.createById(chipset, 0, 4, 8, null, true);
			this.groundSet2 = CellInfoSet.createById(chipset, 1, 5, 9, null, true);
			this.groundSet3 = CellInfoSet.createById(chipset, 2, 6, 10, null, true);
			this.boulder = CellInfo.createChain(chipset, [12, 13, 14]);
			this.boulderL = CellInfo.createById(chipset, 15, false);
			this.sideSet = CellInfoSet.createById(chipset, 3, 7, 11, null, false);
		}
		
		private static var instance:CaveCellInfos;
		
		public static function getInstance():CaveCellInfos {
			if (!instance) {
				instance = new CaveCellInfos();
			}
			return instance;
		}
		
	}
	
}
