﻿
package net.kaikoga.fusalg.cellinfo {
	
	import net.kaikoga.fusalg.cellevent.ACellEvent;
	import net.kaikoga.fusalg.chip.AChip;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	
	/**
	* ...
	* @author kaikoga
	*/
	public class CellInfo {
		
		public var chip:AChip;
		public var enterable:Boolean;
		public var next:CellInfo;
		public var event:ACellEvent;
		
		public function CellInfo(chip:AChip, enterable:Boolean, next:CellInfo = null, event:ACellEvent = null) {
			super();
			this.chip = chip;
			this.enterable = enterable;
			this.next = next;
			this.event = event;
		}
		
		public function toContentString():String {
			return this.chip + ":" + this.enterable + ((this.next) ? "->" + this.next.toContentString():"");
		}
		
		public function toString():String {
			return "[CellInfo "+this.toContentString()+"]";
		}
		
		public static function createById(chipset:DotchipChipSet, id:*, enterable:Boolean, next:CellInfo = null, event:ACellEvent = null):CellInfo {
			var chip:AChip;
			if (id is String) {
				chip = chipset.getChipByName(id);
			} else {
				chip = chipset.getChipByIndex(id);
			}
			return new CellInfo(chip, enterable, next, event);
		}
		
		public static function createChain(chipset:DotchipChipSet, ids:Array, enterables:Array/*Boolean*/ = null):CellInfo {
			var id:*= ids.shift();
			var enterable:Boolean;
			if (enterables) {
				enterable = enterables.shift();
				if (enterables.length == 0) {
					enterables = null;
				}
			} else {
				enterable = (ids.length == 0);
			}
			if (ids.length > 0) {
				return CellInfo.createById(chipset, id, enterable, createChain(chipset, ids, enterables));
			}
			return CellInfo.createById(chipset, id, enterable);
		}
	}
	
}
