﻿
package net.kaikoga.fusalg.cellinfo {
	
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class CellInfoSet {
		
		public var top:CellInfo;
		public var vert:CellInfo;
		public var bottom:CellInfo;
		public var horiz:CellInfo;
		
		public function CellInfoSet(top:CellInfo, vert:CellInfo, bottom:CellInfo, horiz:CellInfo = null) {
			super();
			this.top = top;
			this.vert = vert;
			this.bottom = bottom;
			this.horiz = horiz || vert;
		}
		
		public function getCellInfo(row:int, top:int, bottom:int):CellInfo {
			if (row == top) {
				return this.top;
			} else if (row == bottom) {
				return this.bottom;
			}
			return this.vert;
		}
		
		public static function createById(chipset:DotchipChipSet, topid:*, vertid:*, bottomid:*, horizid:*, enterable:Boolean):CellInfoSet {
			var horiz:CellInfo = horizid ? CellInfo.createById(chipset, horizid, enterable) : null;
			var top:CellInfo = CellInfo.createById(chipset, topid, enterable);
			var vert:CellInfo = CellInfo.createById(chipset, vertid, enterable);
			var bottom:CellInfo = CellInfo.createById(chipset, bottomid, enterable);
			return new CellInfoSet(top, vert, bottom, horiz);
		}
		
		public static function createChains(chipset:DotchipChipSet, topids:Array, vertids:Array, bottomids:Array, horizids:Array, enterables:Array/*Boolean*/):CellInfoSet {
			var horiz:CellInfo = horizids ? CellInfo.createChain(chipset, horizids, enterables.concat()) : null;
			var top:CellInfo = CellInfo.createChain(chipset, topids, enterables.concat());
			var vert:CellInfo = CellInfo.createChain(chipset, vertids, enterables.concat());
			var bottom:CellInfo = CellInfo.createChain(chipset, bottomids, enterables);
			return new CellInfoSet(top, vert, bottom, horiz);
		}
		
	}
	
}
