﻿
package net.kaikoga.fusalg.cellinfo {
	
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class FieldCellInfos {
		
		public var groundSet1:CellInfoSet;
		public var groundSet2:CellInfoSet;
		public var grassSet1:CellInfoSet;
		public var grassSet2:CellInfoSet;
		
		public var shrub:CellInfo;
		public var rock:CellInfo;
		public var bush:CellInfo;
		
		public var sideSet:CellInfoSet;
		
		public function FieldCellInfos() {
			super();
			var chipset:DotchipChipSet = Chips.getInstance().fieldChipM;
			
			this.groundSet1 = CellInfoSet.createById(chipset, 0, 8, 16, null, true);
			this.groundSet2 = CellInfoSet.createById(chipset, 1, 9, 17, null, true);
			this.grassSet1 = CellInfoSet.createById(chipset, 2, 10, 18, null, true);
			this.grassSet2 = CellInfoSet.createById(chipset, 3, 11, 19, null, true);
			
			this.shrub = CellInfo.createChain(chipset, [4, 5, 6]);
			this.rock = CellInfo.createChain(chipset, [12, 13, 14]);
			this.bush = CellInfo.createChain(chipset, [20, 21, 22]);
			
			this.sideSet = CellInfoSet.createById(chipset, 7, 15, 23, null, false);
		}
		
		private static var instance:FieldCellInfos;
		
		public static function getInstance():FieldCellInfos {
			if (!instance) {
				instance = new FieldCellInfos();
			}
			return instance;
		}
		
	}
	
}
