﻿
package net.kaikoga.fusalg.cellinfo {
	
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class FortressCellInfos {
		
		public var groundSet:CellInfoSet;
		public var barricadeHSet:CellInfoSet;
		public var fenceHSet:CellInfoSet;
		public var sideSet:CellInfoSet;

		public function FortressCellInfos() {
			super();
			var chipset:DotchipChipSet = Chips.getInstance().fortressChipM;
			this.groundSet = CellInfoSet.createById(chipset, 0, 8, 16, null, true);
			this.barricadeHSet = CellInfoSet.createChains(chipset, [2, 10, 18], [3, 11, 19], [4, 12, 20], null, [false, false, true]);
			this.fenceHSet = CellInfoSet.createChains(chipset, [5, 13, 21], [6, 14, 22], [7, 15, 23], null, [false, false, true]);
			this.sideSet = CellInfoSet.createById(chipset, 1, 9, 17, null, false);
		}
		
		private static var instance:FortressCellInfos;
		
		public static function getInstance():FortressCellInfos {
			if (!instance) {
				instance = new FortressCellInfos();
			}
			return instance;
		}
		
	}
	
}
