﻿
package net.kaikoga.fusalg.cellinfo {
	
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class MansionCellInfos {
		
		public var groundSet:CellInfoSet;
		public var carpet:CellInfo;
		public var coffin1:CellInfo;
		public var coffin2:CellInfo;
		public var skeleton:CellInfo;
		public var wallSet:CellInfoSet;
		public var sideSet:CellInfoSet;

		public function MansionCellInfos() {
			super();
			var chipset:DotchipChipSet = Chips.getInstance().mansionChipM;
			
			this.groundSet = CellInfoSet.createById(chipset, 0, 8, 16, null, true);
			this.carpet = CellInfo.createById(chipset, 1, true);
			this.coffin1 = CellInfo.createById(chipset, 2, false);
			this.coffin2 = CellInfo.createById(chipset, 3, false);
			this.skeleton = CellInfo.createChain(chipset, [9, 10, 11]);
			this.wallSet = CellInfoSet.createChains(chipset, [5, 6, 7], [13, 14, 15], [21, 22, 23], [17, 18, 19], [false, false, true]);
			this.sideSet = CellInfoSet.createById(chipset, 4, 12, 20, null, false);
		}
		
		private static var instance:MansionCellInfos;
		
		public static function getInstance():MansionCellInfos {
			if (!instance) {
				instance = new MansionCellInfos();
			}
			return instance;
		}
		
	}
	
}
