﻿
package net.kaikoga.fusalg.cellinfo {
	
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class RemnantCellInfos {
		
		public var groundSet1:CellInfoSet;
		public var groundSet2:CellInfoSet;
		public var wallSet:CellInfoSet;
		public var sideHSet:CellInfoSet;

		public function RemnantCellInfos() {
			super();
			var chipset:DotchipChipSet = Chips.getInstance().remnantChipM;
			
			this.groundSet1 = CellInfoSet.createById(chipset, 0, 8, 16, null, true);
			this.groundSet2 = CellInfoSet.createById(chipset, 1, 9, 17, null, true);
			this.wallSet = CellInfoSet.createChains(chipset, [5, 6, 7], [13, 14, 15], [21, 22, 23], [2, 3, 4], [false, false, true]);
			this.sideHSet = CellInfoSet.createById(chipset, 18, 19, 20, null, false);
		}
		
		private static var instance:RemnantCellInfos;
		
		public static function getInstance():RemnantCellInfos {
			if (!instance) {
				instance = new RemnantCellInfos();
			}
			return instance;
		}
		
	}
	
}
