﻿
package net.kaikoga.fusalg.cellinfo {
	
	import net.kaikoga.fusalg.cellevent.AccesoryShopCellEvent;
	import net.kaikoga.fusalg.cellevent.ArmorShopCellEvent;
	import net.kaikoga.fusalg.cellevent.MascotShopCellEvent;
	import net.kaikoga.fusalg.cellevent.WeaponShopCellEvent;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class TownCellInfos {
		
		public var ggrs:CellInfo;
		public var gstn:CellInfo;
		public var gwod:CellInfo;
		public var gcpt:CellInfo;
		public var bcnt:CellInfo;
		public var bhrz:CellInfo;
		public var btop:CellInfo;
		public var bvrt:CellInfo;
		public var bbtm:CellInfo;
		public var stop:CellInfo;
		public var svrt:CellInfo;
		public var sbtm:CellInfo;
		public var owpn:CellInfo;
		public var oarm:CellInfo;
		
		public var WEPN:CellInfo;
		public var ARMR:CellInfo;
		public var ACCS:CellInfo;
		public var MSCT:CellInfo;

		public function TownCellInfos() {
			super();
			var chipset:DotchipChipSet = Chips.getInstance().townChipM;
			
			this.ggrs = CellInfo.createById(chipset, 0, true);
			this.gstn = CellInfo.createById(chipset, 1, true);
			this.gwod = CellInfo.createById(chipset, 2, true);
			this.gcpt = CellInfo.createById(chipset, 3, true);
			
			this.bcnt = CellInfo.createChain(chipset, [8, 9, 10]);
			this.bhrz = CellInfo.createChain(chipset, [16, 17, 18]);
			this.btop = CellInfo.createChain(chipset, [4, 5, 6]);
			this.bvrt = CellInfo.createChain(chipset, [12, 13, 14]);
			this.bbtm = CellInfo.createChain(chipset, [20, 21, 22]);
			
			this.stop = CellInfo.createById(chipset, 7, false);
			this.svrt = CellInfo.createById(chipset, 15, false);
			this.sbtm = CellInfo.createById(chipset, 23, false);
			
			this.owpn = CellInfo.createById(chipset, 11, false);
			this.oarm = CellInfo.createById(chipset, 19, false);

			this.WEPN = CellInfo.createById(chipset, 3, true, null, new WeaponShopCellEvent());
			this.ARMR = CellInfo.createById(chipset, 3, true, null, new ArmorShopCellEvent());
			this.ACCS = CellInfo.createById(chipset, 3, true, null, new AccesoryShopCellEvent());
			this.MSCT = CellInfo.createById(chipset, 3, true, null, new MascotShopCellEvent());
		}
		
		private static var instance:TownCellInfos;
		
		public static function getInstance():TownCellInfos {
			if (!instance) {
				instance = new TownCellInfos();
			}
			return instance;
		}
		
	}
	
}
