﻿
package net.kaikoga.fusalg.chip {
	
	import flash.display.BitmapData;
	import flash.geom.ColorTransform;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	/**
	* ...
	* @author kaikoga
	*/
	public class DotchipChip extends AChip {
		
		private var sourceBitmap:BitmapData;
		private var bounds:Array/*Rectangle*/;
		private var trimmedBitmap:BitmapData = null;
		
		private static var nullPoint:Point = new Point(0, 0);
		
		public function DotchipChip(name:String, sourcebitmap:BitmapData, bounds:Array/*Rectangle*/) {
			super();
			this.name = name;
			this.sourceBitmap = sourcebitmap;
			this.bounds = bounds;
		}
		
		override public function copySelf(bitmapData:BitmapData, dir:int, pt:Point):void {
			bitmapData.copyPixels(this.sourceBitmap, this.bounds[dir], pt);
		}
		
		override public function drawSelf(bitmapData:BitmapData, dir:int, matrix:Matrix, colortransform:ColorTransform = null, blendmode:String = null):void {
			var bitmap:BitmapData = this.trimmedBitmap;
			if (!bitmap) {
				var bound:Rectangle = this.bounds[dir];
				bitmap = new BitmapData(bound.width, bound.height, true, 0x00000000);
				bitmap.copyPixels(this.sourceBitmap, bound, nullPoint);
				this.trimmedBitmap = bitmap;
			}
			bitmapData.draw(bitmap, matrix, colortransform, blendmode);
		}
		
		public function toString():String {
			return "[DotchipChip "+this.name+"]";
		}
	}
	
}
