﻿
package net.kaikoga.fusalg.field {
	
	import net.kaikoga.fusalg.cellevent.ACellEvent;
	import net.kaikoga.fusalg.cellinfo.CellInfo;
	import net.kaikoga.fusalg.chip.AChip;
	import net.kaikoga.fusalg.chip.DotchipChipSet;

	/**
	 * ...
	 * @author kaikoga
	 */
	public class Cell {
		
		private var cellInfo:CellInfo;

		private var chip:AChip;
		public var isEnterable:Boolean = true;
		public var event:ACellEvent;
		
		public function Cell(cellinfo:CellInfo) {
			super();
			if (cellinfo) {
				this.reset(cellinfo);
			}
		}
		
		public function reset(cellinfo:CellInfo):void {
			this.cellInfo = cellinfo;
			this.chip = cellinfo.chip;
			this.isEnterable = cellinfo.enterable;
			this.event = cellinfo.event;
		}
		
		public function takeDamage():Boolean {
			if (this.cellInfo.next) {
				this.reset(this.cellInfo.next);
				return true;
			}
			return false;
		}
		
		public function drawSelf(field:Field, offsetx:int, offsety:int):void {
			field.drawChip(chip, 0, offsetx, offsety);
		}
	}
	
}
