﻿
package net.kaikoga.fusalg.field {
	
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.debug.EDebug;
	import net.kaikoga.fusalg.mortal.ally.Amira;
	import net.kaikoga.fusalg.mortal.ally.Ghanae;
	import net.kaikoga.fusalg.mortal.ally.Silruy;
	import net.kaikoga.fusalg.mortal.ally.Waltz;
	import net.kaikoga.fusalg.strings.FusalgStrings;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class Flags {
		
		public var amira:Amira = null;
		public var waltz:Waltz = null;
		public var ghanae:Ghanae = null;
		public var silruy:Silruy = null;
		
		public var gold:int = 0;
		
		public var hour:int = 6;
		public var minute:int = 0;
		public var second:int = 0;
		
		public var wurmLiving:Boolean = true;
		public var hydraLiving:Boolean = true;
		
		public var timeEnabled:Boolean = false;
		
		public function Flags() {
			super();
			if (EDebug.CHEAT_ALL_HEROINE) {
				this.amira = new Amira();
				this.waltz = new Waltz();
				this.ghanae = new Ghanae();
				this.silruy = new Silruy();
			}
		}
		
		public function frameMove(field:Field):void {
			if (!this.timeEnabled) {
				return;
			}
			this.second += EDebug.DEBUG_TIME ? 37 : 2;
			if (this.second >= 60) {
				this.second -= 60;
				if (++this.minute >= 60) {
					this.minute -= 60;
					switch (++this.hour) {
						case 9:
						field.messageLayer.flush();
						field.messageLayer.message(field, FusalgStrings.getString("bell9"));
						field.audioPlayer.tryPreemptAudio(Sounds.getInstance().bell);
						break;
						case 12:
						field.messageLayer.flush();
						field.messageLayer.message(field, FusalgStrings.getString("bell12"));
						field.audioPlayer.tryPreemptAudio(Sounds.getInstance().bell);
						break;
						case 15:
						field.messageLayer.flush();
						field.messageLayer.message(field, FusalgStrings.getString("bell15"));
						field.audioPlayer.tryPreemptAudio(Sounds.getInstance().bell);
						break;
						case 18:
						field.messageLayer.flush();
						field.messageLayer.message(field, FusalgStrings.getString("bell18"));
						field.audioPlayer.tryPreemptAudio(Sounds.getInstance().bell);
						break;
					}
				}
			}
		}
		
		private function twoDigitString(value:int):String {
			return ((value < 10) ? "0" : "") + String(value);
		}
		
		public function getTimeString():String {
			return this.twoDigitString(this.hour) + ":" + this.twoDigitString(this.minute) + ":" + this.twoDigitString(this.second);
		}
		
		public function pay(value:int):Boolean {
			var result:Boolean = this.gold >= value;
			if (result) {
				this.gold -= value;
			}
			return result;
		}
		
		public function timeIsBefore(hour:int, minute:int, second:int = 0):Boolean {
			if (hour > this.hour) {
				return true;
			} else if (hour < this.hour) {
				return false;
			}
			if (minute > this.minute) {
				return true;
			} else if (minute < this.minute) {
				return false;
			}
			return (second > this.second);
		}
		
		public function timeToSeconds(hour:int = -1, minute:int = 0, second:int = 0):int {
			if (hour < 0) {
				hour = this.hour;
				minute = this.minute;
				second = this.second;
			}
			return hour * 3600 + minute * 60 + second;
		}
		
		public function getProceeding(hourstart:int = 0, minutestart:int = 0, hourend:int = 24, minuteend:int = 0):Number {
			var sstart:int = this.timeToSeconds(hourstart, minutestart);
			var send:int = this.timeToSeconds(hourend, minuteend);
			var selapsed:int = this.timeToSeconds()-sstart;
			var srange:int = send-sstart;
			var result:Number = selapsed / srange;
			return (result > 1) ? 1 : (result < 0) ? 0 : result;
		}
		
	}
	
}
