﻿
package net.kaikoga.fusalg.layer {
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import net.kaikoga.fusalg.area.Areas;
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.chip.AChip;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.debug.EDebug;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.strings.FusalgStrings;
	import net.kaikoga.fusalg.util.KeyEventRecord;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class EndingLayer extends ALayer {
		
		public var frame:int = -384;
		
		public static const FRAME_MAX:int = 900;
		
		private var textField:TextField;
		
		public var endType:String = "end0";
		
		public function EndingLayer() {
			super();
			this.textField = new TextField();
			this.textField.width = 288;
			this.textField.height = 24;
			this.textField.defaultTextFormat = new TextFormat("ＭＳ ゴシック", 12, 0xffffff, true);
			this.textField.wordWrap = false;
		}

		override public function onActivate(field:Field):void {
			this.frame = -384;
			if (!field.heroine) {
				this.endType = "end0";
			}
			field.flags.timeEnabled = false;
			field.keyState.flushEvents();
			switch (this.endType) {
				case "end5":
				case "end6":
				field.audioPlayer.trySwapAudio(Sounds.getInstance().music4);
				break;
				default:
				field.audioPlayer.trySwapAudio(Sounds.getInstance().music1);
				break;
			}
			field.nextArea(Areas.getTownEntry(field, 7));
		}
		
		override public function frameMove(field:Field):Boolean {
			if (field.keyState.getStateOfKey("z")) {
				frame += 4;
			}
			if (frame < FRAME_MAX) {
				field.keyState.flushEvents();
				frame++;
			}
			if (frame > FRAME_MAX) {
				frame = FRAME_MAX;
			}
			for (var record:KeyEventRecord = field.keyState.nextEvent(); record; record = field.keyState.nextEvent()) {
				if (record.type == KeyEventRecord.KEY_DOWN) {
					continue;
				}
				switch (record.key) {
					case "z":
					field.initTitle(true, true);
					return false;
					break;
				}
			}
			return true;
		}

		private function drawEndingChip(field:Field, chip:AChip, y:int):void {
			field.drawChip(chip, 0, 32, y - this.frame, true);
		}
		
		private function drawEndingMessage(field:Field, message:String, y:int):void {
			this.drawEndingChip(field, Chips.getInstance().endMessage.getChipByName("endmessage"), y);
			this.textField.text = message;
			field.drawEtc(this.textField, 32, y - this.frame, true);
		}
		
		override public function drawSelf(field:Field):void {
			super.drawSelf(field);
			this.drawEndingMessage(field, FusalgStrings.getString(this.endType+"_1"), 0);
			this.drawEndingMessage(field, FusalgStrings.getString(this.endType+"_2"), 40);
			this.drawEndingMessage(field, FusalgStrings.getString(this.endType+"_3"), 80);
			this.drawEndingMessage(field, FusalgStrings.getString(this.endType+"_4"), 120);
			this.drawEndingChip(field, Chips.getInstance().titleL.getChipByName("chip"), 300);
			this.drawEndingMessage(field, FusalgStrings.getString("stuff1"), 600);
			this.drawEndingMessage(field, FusalgStrings.getString("stuff2"), 640);
			this.drawEndingMessage(field, FusalgStrings.getString("stuff3"), 680);
			this.drawEndingMessage(field, FusalgStrings.getString("stuff4"), 720);
			this.drawEndingMessage(field, FusalgStrings.getString(this.endType+"_5"), 780);
			//this.drawEndingChip(field, Chips.getInstance().titleL.getChipByName("chip"), 400);
		}
		
	}
	
}
