﻿
package net.kaikoga.fusalg.layer {
	
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.util.KeyEventRecord;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class GameOverLayer extends ALayer {
		
		public function GameOverLayer() {
			super();
			
		}

		override public function onActivate(field:Field):void {
			field.endingLayer.frame = EndingLayer.FRAME_MAX;
			field.flags.timeEnabled = false;
			field.keyState.flushEvents();
			field.audioPlayer.stopChannel("music");
		}
		
		override public function frameMove(field:Field):Boolean {
			for (var record:KeyEventRecord = field.keyState.nextEvent(); record; record = field.keyState.nextEvent()) {
				if (record.type == KeyEventRecord.KEY_DOWN) {
					continue;
				}
				switch (record.key) {
					case "z":
					field.initTitle();
					return false;
					break;
				}
			}
			return true;
		}

		override public function drawSelf(field:Field):void {
			super.drawSelf(field);
			field.drawChip(Chips.getInstance().gameOverL.getChipByName("gameover"), 0, 32, 64, true);
		}
		
	}
	
}
