﻿
package net.kaikoga.fusalg.layer {
	import flash.text.TextFormatAlign;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.debug.EDebug;
	import net.kaikoga.fusalg.field.Field;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class MaskLayer extends ALayer {
		
		private var chips:Chips;
		
		public function MaskLayer() {
			super();
			this.chips = Chips.getInstance();
		}
		
		override public function drawSelf(field:Field):void {
			super.drawSelf(field);
			field.drawChip(chips.frameB.getChipByName("chip"), 0, 0, 352, true);
			
			var plife:int = field.avatar.life;
			field.drawString(String(plife), 64 + plife, 360, TextFormatAlign.LEFT, true);
			field.drawChip(chips.gaugeM.getChipByIndex(plife), 0, 64, 352, true);
			
			var blife:int = field.area.getBossLife();
			if (blife > 0) {
				field.drawString(String(blife), blife + 64, 336, TextFormatAlign.LEFT, true);
				field.drawChip(chips.gaugeS.getChipByIndex(blife), 0, 64, 336, true);
			}
			
			field.drawChip(chips.frameR.getChipByName("chip"), 0, 352, 0, true);
			
			field.drawString(field.area.areaText, 352, 0, TextFormatAlign.LEFT, true);
			field.drawString(field.area.areaNameText, 352, 16, TextFormatAlign.LEFT, true);
			field.drawChip(chips.targetL.getChipByName(field.area.targetName), 0, 400, 32, true);

			if (EDebug.SHOW_TIME) {
				field.drawString(field.flags.getTimeString(), 496, 96, TextFormatAlign.RIGHT, true);
			}
			
			if (field.heroine) {
				field.drawChip(chips.name.getChipByName(field.heroine.nameName), 0, 352, 112, true);
				var hlevel:int = field.heroine.level;
				field.drawString(String(hlevel), 384 + hlevel * 2, 144, TextFormatAlign.LEFT, true);
				field.drawChip(chips.gaugeS.getChipByIndex(hlevel * 2), 0, 384, 144, true);
				var hexp:int = field.heroine.exp;
				field.drawString(String(hexp), 384 + hexp, 160, TextFormatAlign.LEFT, true);
				field.drawChip(chips.gaugeS.getChipByIndex(hexp), 0, 384, 160, true);
				field.drawChip(chips.name.getChipByName(field.heroine.skillName), 0, 352, 176, true);
				var hattack:int = field.heroine.attackLevel;
				field.drawString(String(hattack), 416, 192, TextFormatAlign.LEFT, true);
				var haura:int = field.heroine.auraLevel;
				field.drawString(String(haura), 496, 192, TextFormatAlign.LEFT, true);
			}
			
			field.drawString(String(field.flags.gold), 480, 224, TextFormatAlign.RIGHT, true);
			
			var plevel:int = field.avatar.level;
			field.drawString(String(plevel), 384 + plevel * 2, 288, TextFormatAlign.LEFT, true);
			field.drawChip(chips.gaugeS.getChipByIndex(plevel * 2), 0, 384, 288, true);
			var pexp:int = field.avatar.exp;
			field.drawString(String(pexp), 384 + pexp, 304, TextFormatAlign.LEFT, true);
			field.drawChip(chips.gaugeS.getChipByIndex(pexp), 0, 384, 304, true);

			var sword:int = field.avatar.swordLevel;
			field.drawString(String(sword), 384, 336, TextFormatAlign.LEFT, true);
			var axe:int = field.avatar.axeLevel;
			field.drawString(String(axe), 432, 336, TextFormatAlign.LEFT, true);
			var shield:int = field.avatar.shieldLevel;
			field.drawString(String(shield), 480, 336, TextFormatAlign.LEFT, true);
			
		}
		
	}
	
}
