﻿
package net.kaikoga.fusalg.layer {
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.util.KeyEventRecord;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class MessageLayer extends ALayer {
		
		public var life:int = 0;
		public var textQueue:Array;
		private var textField:TextField;
		
		private static const MESSAGE_HEIGHT:int = 56;
		
		public function MessageLayer() {
			super();
			this.textQueue = [];
			this.textField = new TextField();
			this.textField.width = 344;
			this.textField.height = MESSAGE_HEIGHT - 4;
			this.textField.defaultTextFormat = new TextFormat("ＭＳ ゴシック", 12, 0xffffff, true);
			this.textField.wordWrap = true;
		}
		
		public function flush():void {
			if (this.life == MESSAGE_HEIGHT) {
				this.life -= 2;
			}
		}
		
		
		protected function pushMessage(value:String):void {
			if (this.life == MESSAGE_HEIGHT) {
				this.textQueue.push(value);
			} else {
				this.textField.text = value;
				this.life = MESSAGE_HEIGHT;
			}
		}

		public function message(field:Field, value:String):void {
			field.audioPlayer.tryStartAudio(Sounds.getInstance().seMessage);
			field.enableLayer(this);
			var values:Array = value.split("//");
			var c:int = values.length;
			for (var i:int = 0; i < c; i++) {
				this.pushMessage(values[i]);
			}
		}
		
		private function nextMessage():void {
			if (this.textQueue.length > 0) {
				this.textField.text = this.textQueue.shift();
			} else {
				this.life = MESSAGE_HEIGHT - 2;
			}
		}
		
		override public function onActivate(field:Field):void {
			field.keyState.flushEvents();
		}
		
		override public function frameMove(field:Field):Boolean {
			if (this.life < MESSAGE_HEIGHT) {
				this.life -= 2;
				return true;
			}
			for (var record:KeyEventRecord = field.keyState.nextEvent(); record; record = field.keyState.nextEvent()) {
				if (record.type == KeyEventRecord.KEY_DOWN) {
					continue;
				}
				switch (record.key) {
					case "z":
					field.audioPlayer.tryStartAudio(Sounds.getInstance().seMessage);
					this.nextMessage();
					break;
				}
			}
			return true;
		}
		
		override public function drawSelf(field:Field):void {
			if (this.life < 0) {
				return;
			}
			field.drawChip(Chips.getInstance().message.getChipByName("message"), 0, 0, 352 - this.life, true);
			field.drawEtc(this.textField, 4, 356 - this.life, true);
		}
		
	}
	
}
