﻿
package net.kaikoga.fusalg.layer {
	
	import net.kaikoga.fusalg.area.town.AreaTown_1;
	import net.kaikoga.fusalg.area.town.AreaTown_2;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.debug.EDebug;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.util.KeyEventRecord;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class TitleLayer extends ALayer {
		
		public function TitleLayer() {
			super();
		}

		override public function onActivate(field:Field):void {
			field.keyState.flushEvents();
		}
		
		override public function frameMove(field:Field):Boolean {
			for (var record:KeyEventRecord = field.keyState.nextEvent(); record; record = field.keyState.nextEvent()) {
				if (record.type == KeyEventRecord.KEY_DOWN) {
					continue;
				}
				switch (record.key) {
					case "z":
					field.flags.timeEnabled = true;
					if (EDebug.DEBUG_CHEAT) {
						field.nextArea(new AreaTown_2(EDebug.CHEAT_START_AREA));
						field.flags.gold = 10000;
						field.avatar.level = EDebug.CHEAT_START_LEVEL - 1;
						field.avatar.exp = 99;
						field.avatar.gainExp(field, 1);
					} else {
						field.nextArea(new AreaTown_1(1));
					}
					return false;
					break;
				}
			}
			return true;
		}

		override public function drawSelf(field:Field):void {
			super.drawSelf(field);
			field.drawChip(Chips.getInstance().titleL.getChipByName("chip"), 0, 32, 64, true);
		}
		
	}
	
}
