﻿
package net.kaikoga.fusalg.mortal {
	
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	import net.kaikoga.fusalg.field.Field;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class AMortal {
		
		public static const DIR_RIGHT:int = 0;
		public static const DIR_UP:int = 1;
		public static const DIR_LEFT:int = 2;
		public static const DIR_DOWN:int = 3;
		
		public var chips:DotchipChipSet;
		public var chipShift:Point;
		public var position:Point;
		public var dir:int;
		public var frame:int;
		public var chipName:String;
		
		public var physicalBound:Rectangle;
		public var projectileBound:Rectangle;
		public var isProjectile:Boolean = false;
		public var physicalDamage:int = 0;
		public var projectileDamage:int = 0;
		
		private static var DEFAULT_CHIP_SHIFT:Point = new Point( -16, -24);

		public function AMortal(chips:DotchipChipSet) {
			super();
			this.chips = chips;
			this.position = new Point();
			this.chipShift = DEFAULT_CHIP_SHIFT;
		}
		
		public function onHit(field:Field, src:AMortal):void {
			;
		}
		
		public function checkHit(src:AMortal):Boolean {
			var srcbound:Rectangle;
			var mybound:Rectangle;
			if (src.isProjectile) {
				srcbound = src.projectileBound;
				mybound = this.projectileBound;
			} else {
				srcbound = src.physicalBound;
				mybound = this.physicalBound;
			}
			if (srcbound && mybound) {
				return ((this.position.x + mybound.x < src.position.x + srcbound.right) &&
					(this.position.x + mybound.right > src.position.x + srcbound.x) &&
					(this.position.y + mybound.y < src.position.y + srcbound.bottom) &&
					(this.position.y + mybound.bottom > src.position.y + srcbound.y)
					);
			}
			return false;
		}
		
		public function willDispose():Boolean {
			return ((this.position.x < Field.BOUND_X_MIN) ||
				(this.position.x > Field.BOUND_X_MAX) ||
				(this.position.y < Field.BOUND_Y_MIN) ||
				(this.position.y > Field.BOUND_Y_MAX)
				);
		}
		
		public function onAdd(field:Field):void {
			;
		}
		
		public function onDispose(field:Field):void {
			;
		}
		
		public function frameMove(field:Field):void {
			;
		}
		
		public function shift(dx:int, dy:int):void {
			this.position.x += dx;
			this.position.y += dy;
		}
		
		public function drawSelf(field:Field):void {
			var x:int = this.position.x;
			var y:int = this.position.y;
			if (this.chipShift) {
				x += this.chipShift.x;
				y += this.chipShift.y;
			}
			field.drawChip(this.chips.getChipByName(this.chipName), this.dir, x, y);
		}
		
	}
	
}
