﻿
package net.kaikoga.fusalg.mortal {

	import net.kaikoga.fusalg.chip.DotchipChipSet;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.ACharacter;
	import net.kaikoga.fusalg.mortal.AMortal;
	import net.kaikoga.fusalg.mortal.effects.SparkEffectL;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class APart extends AMortal {
		
		protected var parent:ACharacter;
		
		public function APart(parent:ACharacter, chips:DotchipChipSet, chipname:String) {
			super(chips);
			this.parent = parent;
			this.chipName = chipname;
			this.position.x = parent.position.x;
			this.position.y = parent.position.y;
		}
		
		override public function onHit(field:Field, src:AMortal):void {
			if (this.parent) {
				parent.onHit(field, src);
			}
		}
		
		public function dispose():void {
			this.parent = null;
		}
		
		public function onKill(field:Field):void {
			field.addEffect(new SparkEffectL(-1, 0), this.position.x, this.position.y);
		}
		
		public function moveRelative(x:int, y:int):void {
			if (this.parent) {
				this.position.x = this.parent.position.x + x;
				this.position.y = this.parent.position.y + y;
			}
		}
		
		public function delayMoveRelative(x:int, y:int, weight:Number = 0.5):void {
			if (this.parent) {
				this.position.x = this.position.x * (1 - weight) + (this.parent.position.x + x) * weight;
				this.position.y = this.position.y * (1 - weight) + (this.parent.position.y + y) * weight;
			}
		}
		
		override public function willDispose():Boolean {
			return (this.parent == null);
		}
		
		override public function drawSelf(field:Field):void {
			if ((this.parent && (this.parent.invincibleFrames < 0)) || field.drawBlink) {
				super.drawSelf(field);
			}
		}
		
	}
	
}
