﻿
package net.kaikoga.fusalg.mortal {
	
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	import net.kaikoga.fusalg.field.Field;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class AWarriorProjectile extends AMortal {
		
		public var life:int;
		public var speed:int;
		public var range:int;
		
		public function AWarriorProjectile(chips:DotchipChipSet, life:int = 8, speed:int = 4, range:int = 64) {
			super(chips);
			this.life = life;
			this.speed = speed;
			this.range = range;
			this.isProjectile = true;
		}
		
		override public function willDispose():Boolean {
			return (life < 0);
		}
		
		protected function reposition():void {
			switch (this.dir) {
				case DIR_RIGHT:
				this.position.x += this.range - (life * speed);
				break;
				case DIR_UP:
				this.position.y -= this.range - (life * speed);
				break;
				case DIR_LEFT:
				this.position.x -= this.range - (life * speed);
				break;
				case DIR_DOWN:
				this.position.y += this.range - (life * speed);
				break;
			}
		}

		override public function frameMove(field:Field):void {
			if (--this.life >= 0) {
				this.reposition();
			}
		}
		
		override public function drawSelf(field:Field):void {
			if (this.life >= 0) {
				super.drawSelf(field);
			}
		}
	}
	
}
