﻿
package net.kaikoga.fusalg.mortal.ally {
	
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.AMortal;
	import net.kaikoga.fusalg.mortal.assist.AmiraFire;
	import net.kaikoga.fusalg.mortal.enemya.Jien;
	import net.kaikoga.fusalg.mortal.enemya.Umaa;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class Amira extends AHeroine {
		
		private static const CHIP_NAMES:Array/*String*/= ["amira", "amira0", "amira1", "amira2"];
		
		public function Amira() {
			super(Chips.getInstance().allyChipM, CHIP_NAMES);
			this.nameName = "amira";
			this.skillName = "amira_s";
			this.runSpeed = 3;
			this.warpSpeed = 4;
		}
		
		override protected function getNextMessageWait():int {
			return 1200;
		}
		
		override public function assistAttack(field:Field):void {
			var target:AMortal = field.getRandomEnemy();
			if (target && this.canAssist()) {
				this.addAssist(field, new AmiraFire(this, target, this.attackLevel));
			}
		}
		
		override public function assistAura(field:Field):void {
			if (field.avatar.canAddAura()) {
				field.avatar.addAura(field, new Aura(Aura.AURA_POWER, this.auraLevel));
			}
		}
		
	}
	
}
