﻿
package net.kaikoga.fusalg.mortal.ally {
	
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.AMortal;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class Aura extends AMortal {
		
		public var type:String;
		public var life:int;
		public var level:int;
		
		public static const AURA_POWER:String = "power";
		public static const AURA_HEAL:String = "heal";
		public static const AURA_ACCEL:String = "accel";
		public static const AURA_BARRIER:String = "barrier";
		
		private static const CHIPNAMES_TYPE:Object/*Array*/= {
			power:["power1", "power2"],
			heal:["heal1", "heal2"],
			accel:["accel1", "accel2"],
			barrier:["barrier1", "barrier2"]
		};
		
		public function Aura(type:String, level:int) {
			super(Chips.getInstance().magicChipM);
			this.type = type;
			this.level = level;
			this.life = 256 + level * 32;
		}
		
		override public function willDispose():Boolean {
			return (this.life <= 0);
		}
		
		override public function frameMove(field:Field):void {
			super.frameMove(field);
			this.frame++;
			this.chipName = CHIPNAMES_TYPE[this.type][(this.frame++ & 2) ? 0 : 1];
			this.life--;
		}
		
	}
	
}
