﻿
package net.kaikoga.fusalg.mortal.ally {
	
	import flash.geom.Rectangle;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.AMortal;
	import net.kaikoga.fusalg.mortal.AWarriorProjectile;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class FusaProjectile extends AWarriorProjectile {
		
		public function FusaProjectile(chips:DotchipChipSet, life:int = 8, speed:int = 4, range:int = 64, damage:int = 1) {
			super(chips, life, speed, (damage > 1) ? 64 : 32);
			this.projectileBound = new Rectangle(-16, -24, 32, 32);
			this.projectileDamage = damage;
			this.chipName = (damage > 1) ? "wave1" : "wave2";
		}
		
		override public function frameMove(field:Field):void {
			super.frameMove(field);
			for (var i:int = field.enemies.length - 1; i >= 0; i--) {
				var enemy:AMortal = AMortal(field.enemies[i]);
				if (enemy.checkHit(this)) {
					this.onHit(field, enemy);
					enemy.onHit(field, this);
				}
			}
		}
		
	}
	
}
