﻿
package net.kaikoga.fusalg.mortal.ally {
	
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.AMortal;
	import net.kaikoga.fusalg.mortal.assist.GhanaeFist;
	import net.kaikoga.fusalg.util.FusalgMath;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class Ghanae extends AHeroine {
		
		private static const CHIP_NAMES:Array/*String*/= ["ghanae", "ghanae0", "ghanae1", "ghanae2"];
		
		public function Ghanae() {
			super(Chips.getInstance().allyChipM, CHIP_NAMES);
			this.nameName = "ghanae";
			this.skillName = "ghanae_s";
			this.physicalDamage = 4;
			this.runSpeed = 6;
			this.warpSpeed = 6;
		}
		
		override protected function onLevelUp():void {
			super.onLevelUp();
			switch (FusalgMath.randomInt(1, 3)) {
				case 1:
				if (++this.attackLevel > 9) {
					this.attackLevel = 9;
				}
				break;
				case 2:
				if (++this.auraLevel > 9) {
					this.auraLevel = 9;
				}
				break;
			}
		}
		
		override protected function getNextMessageWait():int {
			return 3000;
		}
		
		override public function assistAttack(field:Field):void {
			var target:AMortal = field.getRandomEnemy();
			if (target && this.canAssist()) {
				this.addAssist(field, new GhanaeFist(this, target, this.attackLevel));
			}
		}
		
		override public function assistAura(field:Field):void {
			if (field.avatar.canAddAura()) {
				field.avatar.addAura(field, new Aura(Aura.AURA_ACCEL, this.auraLevel));
			}
		}
		
	}
	
}
