﻿
package net.kaikoga.fusalg.mortal.ally {
	
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.AMortal;
	import net.kaikoga.fusalg.mortal.assist.SilruyBomb;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class Silruy extends AHeroine {
		
		private static const CHIP_NAMES:Array/*String*/= ["silruy", "silruy0", "silruy1", "silruy2"];
		
		public function Silruy() {
			super(Chips.getInstance().allyChipM, CHIP_NAMES);
			this.nameName = "silruy";
			this.skillName = "silruy_s";
			this.physicalDamage = 1;
			this.runSpeed = 2;
			this.warpSpeed = 4;
		}
		
		override protected function getNextMessageWait():int {
			return 400;
		}
		
		override public function assistAttack(field:Field):void {
			var target:AMortal = field.getRandomEnemy();
			if (target && this.canAssist()) {
				this.addAssist(field, new SilruyBomb(this, target, this.attackLevel));
			}
		}
		
		override public function assistAura(field:Field):void {
			if (field.avatar.canAddAura()) {
				field.avatar.addAura(field, new Aura(Aura.AURA_BARRIER, this.auraLevel));
			}
		}
		
	}
	
}
