﻿
package net.kaikoga.fusalg.mortal.ally {
	
	import net.kaikoga.fusalg.chip.AChip;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.AMortal;
	import net.kaikoga.fusalg.mortal.assist.WaltzArrow;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class Waltz extends AHeroine {

		private static const CHIP_NAMES:Array/*String*/= ["waltz", "waltz0", "waltz1", "waltz2"];
		
		private static const BOW_SHIFT_X:Array/*int*/= [-8, -16, -24, -16];
		private static const BOW_SHIFT_Y:Array/*int*/= [-16, -24, -16, -8];
		
		private var bowChip:AChip;
		private var bowFrame:int = 0;
		
		public function Waltz() {
			super(Chips.getInstance().allyChipM, CHIP_NAMES);
			this.nameName = "waltz";
			this.skillName = "waltz_s";
			this.physicalDamage = 2;
			this.runSpeed = 3;
			this.warpSpeed = 6;
			this.bowChip = Chips.getInstance().arrowChipM.getChipByName("bow");
		}
		
		override protected function getNextMessageWait():int {
			return 1800;
		}
		
		override public function assistAttack(field:Field):void {
			var target:AMortal = field.getRandomEnemy();
			if (target && this.canAssist()) {
				this.addAssist(field, new WaltzArrow(this, target, this.attackLevel));
				this.bowFrame = 6;
			}
		}
		
		override public function assistAura(field:Field):void {
			if (field.avatar.canAddAura()) {
				field.avatar.addAura(field, new Aura(Aura.AURA_HEAL, this.auraLevel));
			}
		}
		
		override public function drawSelf(field:Field):void {
			if (this.dir == DIR_UP) {
				if (this.bowFrame > 0) {
					field.drawChip(this.bowChip, this.dir, this.position.x+BOW_SHIFT_X[this.dir], this.position.y+BOW_SHIFT_Y[this.dir]);
					this.bowFrame--;
				}
				super.drawSelf(field);
			} else {
				super.drawSelf(field);
				if (this.bowFrame > 0) {
					field.drawChip(this.bowChip, this.dir, this.position.x+BOW_SHIFT_X[this.dir], this.position.y+BOW_SHIFT_Y[this.dir]);
					this.bowFrame--;
				}
			}
		}
		
	}
	
}
