﻿
package net.kaikoga.fusalg.mortal.assist {
	
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.ally.Amira;
	import net.kaikoga.fusalg.mortal.AMortal;
	import net.kaikoga.fusalg.util.FusalgMath;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class AmiraFire extends AAssistMortal {
		
		private var parent:Amira;
		
		public function AmiraFire(parent:Amira, target:AMortal, level:int) {
			super(parent, Chips.getInstance().magicChipM);
			this.parent = parent;
			this.chipShift = new Point(-16, -16);
			this.projectileBound = new Rectangle(-16, -16, 32, 32);
			this.projectileDamage = 4 + level;
			this.chipName = "fire1";
			this.dx = (target.position.x - parent.position.x) >> 4;
			this.dy = (target.position.y - parent.position.y) >> 4;
		}
		
		override public function willDispose():Boolean {
			return this.frame > 32;
		}
		
		override public function onAdd(field:Field):void {
			super.onAdd(field);
			field.audioPlayer.tryStartAudio(Sounds.getInstance().seFlame);
		}
		
		override public function frameMove(field:Field):void {
			super.frameMove(field);
			if (++this.frame < 16) {
				this.chipName = (this.frame & 1) ? "fire1" : "fire2";
			} else {
				this.chipName = (this.frame & 1) ? "flame1" : "flame2";
				this.hitsEnemy = true;
				this.dx = FusalgMath.randomInt(-2, 2);
				this.dy = FusalgMath.randomInt(-2, 2);
			}
		}
	}
	
}
