﻿
package net.kaikoga.fusalg.mortal.assist {
	
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.ally.Ghanae;
	import net.kaikoga.fusalg.mortal.AMortal;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class GhanaeFist extends AAssistMortal {
		
		private var parent:Ghanae;
		
		public function GhanaeFist(parent:Ghanae, target:AMortal, level:int) {
			super(parent, Chips.getInstance().magicChipM);
			this.parent = parent;
			this.chipShift = new Point(-16, -16);
			this.projectileBound = new Rectangle(-16, -16, 32, 32);
			this.projectileDamage = parent.physicalDamage + level - 1;
			this.chipName = "fist1";
			this.dx = target.position.x - parent.position.x;
			this.dy = target.position.y - parent.position.y;
			var adx:int = ((this.dx > 0) ? this.dx : -this.dx);
			var ady:int = ((this.dy > 0) ? this.dy : -this.dy)
			this.dx = (this.dx > 0) ? 4 : -4;
			this.dy = (this.dy > 0) ? 4 : -4;
			if (adx > ady) {
				if (adx > ady << 1) {
					this.dx *= 1.5;
					this.dy = 0;
				}
			} else {
				if (ady > adx << 1) {
					this.dy *= 1.5;
					this.dx = 0;
				}
			}
			this.hitsEnemy = true;
		}
		
		override public function onAdd(field:Field):void {
			super.onAdd(field);
			field.audioPlayer.tryStartAudio(Sounds.getInstance().seFist);
		}
		
		override public function willDispose():Boolean {
			return this.frame > 7;
		}
		
		override public function frameMove(field:Field):void {
			super.frameMove(field);
			if (++this.frame > 3) {
				this.chipName = (this.frame & 1) ? "explode1" : "explode2";
			}
		}
	}
	
}
