﻿
package net.kaikoga.fusalg.mortal.assist {
	
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.ally.Silruy;
	import net.kaikoga.fusalg.mortal.AMortal;
	import net.kaikoga.fusalg.util.FusalgMath;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class SilruyBomb extends AAssistMortal {
		
		private var parent:Silruy;
		
		public function SilruyBomb(parent:Silruy, target:AMortal, level:int) {
			super(parent, Chips.getInstance().magicChipM);
			this.parent = parent;
			this.chipShift = new Point(-16, -16);
			this.projectileBound = new Rectangle(-16, -16, 32, 32);
			this.projectileDamage = 8 + level;
			this.chipName = "bomb1";
			this.dx = (target.position.x - parent.position.x) >> 4;
			this.dy = (target.position.y - parent.position.y) >> 4;
			this.dy -= 16;
		}
		
		override public function willDispose():Boolean {
			return this.frame > 32;
		}
		
		override public function onAdd(field:Field):void {
			super.onAdd(field);
		}
		
		override public function frameMove(field:Field):void {
			super.frameMove(field);
			if (this.frame > 16) {
				this.chipName = (this.frame & 2) ? "explode1" : "explode2";
			} else if (this.frame == 16) {
				field.audioPlayer.tryStartAudio(Sounds.getInstance().seBomb);
				this.hitsEnemy = true;
				this.dx = FusalgMath.randomInt(-8, 8);
				this.dy = FusalgMath.randomInt(-8, 8);
			} else if (this.frame < 16) {
				this.dy += 2;
			}
			this.frame++;
		}
		
	}
	
}
