﻿
package net.kaikoga.fusalg.mortal.assist {
	
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.ally.Waltz;
	import net.kaikoga.fusalg.mortal.AMortal;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class WaltzArrow extends AAssistMortal {
		
		private var parent:Waltz;
		
		public function WaltzArrow(parent:Waltz, target:AMortal, level:int) {
			super(parent, Chips.getInstance().arrowChipM);
			this.parent = parent;
			this.chipShift = new Point(-16, -16);
			this.projectileBound = new Rectangle(-16, -16, 32, 32);
			this.projectileDamage = level;
			this.chipName = "arrow";
			this.dx = (target.position.x - parent.position.x);
			this.dy = (target.position.y - parent.position.y);
			this.frame = Math.ceil(Math.sqrt(this.dx * this.dx + this.dy * this.dy) / 32);
			this.dx /= this.frame;
			this.dy /= this.frame;
			if (((this.dx > 0) ? this.dx : -this.dx) > ((this.dy > 0) ? this.dy : -this.dy)) {
				this.dir = (this.dx > 0) ? DIR_RIGHT : DIR_LEFT;
			} else {
				this.dir = (this.dy > 0) ? DIR_DOWN : DIR_UP;
			}
			this.hitsEnemy = true;
		}
		
		override public function onAdd(field:Field):void {
			super.onAdd(field);
			field.audioPlayer.tryStartAudio(Sounds.getInstance().seArrow);
		}
		
		override public function willDispose():Boolean {
			return this.frame <= 0;
		}
		
		override public function frameMove(field:Field):void {
			super.frameMove(field);
			this.frame--;
		}
	}
	
}
