﻿
package net.kaikoga.fusalg.mortal.boss {
	
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.ACharacter;
	import net.kaikoga.fusalg.util.FusalgMath;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class Golem extends ACharacter {
		
		private var chipsM:DotchipChipSet;
		private var chipsL:DotchipChipSet;
		
		private var head:BossPart;
		private var handLeft:BossPart;
		private var handRight:BossPart;
		private var footLeft:BossPart;
		private var footRight:BossPart;
		
		private var dx:int = 0;
		private var dy:int = 4;
		
		public function Golem() {
			this.chipsM = Chips.getInstance().bossChipM;
			this.chipsL = Chips.getInstance().bossChipL;
			super(this.chipsL);
			this.chipName = "go_body";
			this.chipShift = new Point(-32, -48);
			this.physicalBound = new Rectangle(-32, -48, 64, 64);
			this.projectileBound = new Rectangle(-48, -64, 96, 96);
			this.physicalDamage = 30;
			this.head = new BossPart(this, this.chipsM, "go_head");
			this.handLeft = new BossPart(this, this.chipsM, "go_hl");
			this.handRight = new BossPart(this, this.chipsM, "go_hr");
			this.footLeft = new BossPart(this, this.chipsM, "go_fl");
			this.footRight = new BossPart(this, this.chipsM, "go_fr");
			this.life = 300;
			this.armor = 32;
			this.singleDir = true;
			this.killSparkFrames = 60;
			this.killExp = 100;
			this.killGold = 500;
		}
		
		override public function onAdd(field:Field):void {
			super.onAdd(field);
			field.addPart(this.head, 0, -48);
			field.addPart(this.handLeft, -32, -16);
			field.addPart(this.handRight, 32, -16);
			field.addPart(this.footLeft, -16, 16);
			field.addPart(this.footRight, 16, 16);
		}
		
		override public function onDispose(field:Field):void {
			super.onDispose(field);
			this.head.dispose();
			this.handLeft.dispose();
			this.handRight.dispose();
			this.footLeft.dispose();
			this.footRight.dispose();
		}
		
		override public function onKill(field:Field):void {
			super.onKill(field);
			this.head.onKill(field);
			this.handLeft.onKill(field);
			this.handRight.onKill(field);
			this.footLeft.onKill(field);
			this.footRight.onKill(field);
		}
		
		override public function frameMove(field:Field):void {
			super.frameMove(field);
			if (Math.random() < 0.05) {
				this.dx = FusalgMath.randomInt( -2, 2);
			} else if (Math.random() < 0.05) {
				this.dy = (this.position.y < 160) ? 2 : -2;
			} else {
				if (this.position.y > 300) {
					this.dy = -2;
				} else if (this.position.y < 20) {
					this.dy = 2;
				}
			}
			this.moveSelf(field, this.dx, this.dy, 0);
			this.yankBoss(4);
			this.frame++;
			var b:Boolean = Boolean(this.frame & 32);
			this.head.delayMoveRelative(0, (this.frame & 18) ? -48 : -40, 0.2);
			this.handLeft.delayMoveRelative(b ? -48 : -32, b ? -24 : -8, 0.2);
			this.handRight.delayMoveRelative(b ? 32 : 48, b ? -8 : -24, 0.2);
			this.footLeft.delayMoveRelative(-16, b ? 24 : 8, 0.2);
			this.footRight.delayMoveRelative(16, b ? 8 : 24, 0.2);
		}
		
		override public function drawSelf(field:Field):void {
			super.drawSelf(field);
			
		}
		
	}
	
}
