﻿
package net.kaikoga.fusalg.mortal.boss {
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.bullet.FireBullet;
	import net.kaikoga.fusalg.util.FusalgMath;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class HydraHead extends BossPart {

		private static const NECK_COUNT:int = 4;
		private var necks:Array/*BossPart*/;
		private var origdx:int;
		private var origdy:int;
		public var castsFire:Boolean = false;
		
		public function HydraHead(parent:Hydra, chipsM:DotchipChipSet, chipsL:DotchipChipSet) {
			super(parent, chipsL, "hy_head");
			this.necks = [];
			for (var j:int = 0; j < NECK_COUNT; j++) {
				this.necks[j] = new BossPart(parent, chipsM, "hy_neck");
			}
			this.chipShift = new Point( -32, -32);
			this.physicalBound = new Rectangle( -32, -32, 64, 64);
			this.projectileBound = this.physicalBound;
			this.physicalDamage = 20;
		}
		
		public function addNecks(field:Field):void {
			for (var j:int = 0; j < NECK_COUNT; j++) {
				field.addPart(this.necks[j]);
			}
		}

		override public function onAdd(field:Field):void {
			super.onAdd(field);
			this.origdx = this.position.x - this.parent.position.x;
			this.origdy = this.position.y - this.parent.position.y;
		}
		
		override public function onDispose(field:Field):void {
			super.onDispose(field);
			for (var j:int = 0; j < NECK_COUNT; j++) {
				BossPart(this.necks[j]).dispose();
			}
		}
		
		override public function onKill(field:Field):void {
			super.onKill(field);
			for (var j:int = 0; j < NECK_COUNT; j++) {
				BossPart(this.necks[j]).onKill(field);
			}
		}
		
		override public function frameMove(field:Field):void {
			if (++this.frame > 10) {
				this.frame = 0;
				if (this.castsFire) {
					field.addBullet(new FireBullet(8, -8), this.position.x, this.position.y);
					field.addBullet(new FireBullet(8, 0), this.position.x, this.position.y);
					field.addBullet(new FireBullet(8, 8), this.position.x, this.position.y);
				}
			}
			switch (FusalgMath.randomInt(0, 100)) {
				case 0:
				case 1:
				case 2:
				this.origdx = FusalgMath.randomInt(-160, 160);
				this.origdy = FusalgMath.randomInt(-32, 160);
				break;
				case 3:
				break;
			}
			var x:int;
			var y:int;
			var d:Number = 0.2;
			for (var j:int = 0; j < NECK_COUNT; j++) {
				x = this.origdx * d;
				y = this.origdy * d-32;
				BossPart(this.necks[j]).delayMoveRelative(x, y, 1-d);
				d += 0.2;
			}
			this.delayMoveRelative(this.origdx, this.origdy, 0.1);
			super.frameMove(field);
		}

		
	}
	
}
