﻿
package net.kaikoga.fusalg.mortal.boss {
	
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.ACharacter;
	import net.kaikoga.fusalg.mortal.AMortal;
	import net.kaikoga.fusalg.util.FusalgMath;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class Resident extends ACharacter {
		
		private var mansion:Mansion;
		private var dx:int;
		private var dy:int;
		
		private static const CHIP_NAMES:Array/*String*/= ["re_1", "re_2", "re_3", "re_4"];
		
		public static const RESIDENT_LIFE:int = 8;
		
		public function Resident(mansion:Mansion) {
			super(Chips.getInstance().bossChipM);
			this.mansion = mansion;
			this.chipName = CHIP_NAMES[FusalgMath.randomInt(0, CHIP_NAMES.length - 1)];
			this.physicalBound = new Rectangle(-12, -12, 24, 24);
			this.projectileBound = new Rectangle( -20, -20, 40, 40);
			this.physicalDamage = 10;
			this.chipShift = new Point(-16, -16);
			this.dx = FusalgMath.randomInt(-2, 2);
			this.dy = FusalgMath.randomInt(3, 6);
			this.life = RESIDENT_LIFE;
			this.singleDir = true;
		}
		
		override public function frameMove(field:Field):void {
			super.frameMove(field);
			this.position.x += this.dx;
			this.position.y += this.dy;
		}
		
		override public function onDispose(field:Field):void {
			super.onDispose(field);
			this.mansion.life -= RESIDENT_LIFE - this.life;
		}
		
	}
	
}
