﻿
package net.kaikoga.fusalg.mortal.boss {
	
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.ACharacter;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class Wurm extends ACharacter {
		
		private var chipsM:DotchipChipSet;
		private var chipsL:DotchipChipSet;
		
		private var parts:Array/*BossPart*/;
		private static const WURM_BODY_LENGTH:int = 20;
		private static const WURM_LENGTH:int = 30;
		
		public function Wurm() {
			this.chipsM = Chips.getInstance().bossChipM;
			this.chipsL = Chips.getInstance().bossChipL;
			super(this.chipsL);
			this.chipName = "wu_1";
			this.chipShift = new Point(-32, -32);
			this.physicalBound = new Rectangle(-32, -32, 64, 64);
			this.physicalDamage = 40;
			this.projectileBound = new Rectangle(-48, -48, 96, 96);
			this.parts = [];
			var i:int = 0;
			while (i < WURM_BODY_LENGTH) {
				this.parts[i] = new BossPart(this, this.chipsM, (i % 3) ? "wu_1" : null);
				i++;
			}
			while (i < WURM_LENGTH) {
				this.parts[i] = new BossPart(this, this.chipsM, (i % 3) ? "wu_2" : null);
				i++;
			}
			this.parts[WURM_LENGTH] = new BossPart(this, this.chipsM, "wu_3");
			this.life = 250;
			this.singleDir = true;
			this.armor = 32;
			this.killSparkFrames = 60;
			this.killExp = 100;
			this.killGold = 300;
		}
		
		override public function frameMove(field:Field):void {
			super.frameMove(field);
			this.frame++;
			//follow
			for (var i:int = WURM_LENGTH; i > 0; i--) {
				var lpos:Point = BossPart(this.parts[i - 1]).position;
				var pos:Point = BossPart(this.parts[i]).position;
				pos.x = lpos.x;
				pos.y = lpos.y;
			}
			//and move
			lpos.x = 160 + Math.sin(frame * 0.0361) * 200;
			lpos.y = 192 - Math.cos((frame * 0.0631) % Math.PI) * 256 - field.camera.y;
			this.position.x = lpos.x;
			this.position.y = lpos.y;
			this.chipName = (this.frame & 4) ? "wu_1": "wu_2";
		}
		
		override public function willDispose():Boolean {
			return this.willDisposeByLife();
		}
		
		override public function onAdd(field:Field):void {
			super.onAdd(field);
			for (var i:int = 0; i <= WURM_LENGTH; i++) {
				field.addPart(this.parts[i], 2048, 2048);
			}
		}
		
		override public function onDispose(field:Field):void {
			super.onDispose(field);
			for (var i:int = 0; i <= WURM_LENGTH; i++) {
				BossPart(this.parts[i]).dispose();
			}
		}

		override public function onKill(field:Field):void {
			super.onKill(field);
			for (var i:int = 0; i < WURM_LENGTH; i++) {
				BossPart(this.parts[i]).onKill(field);
			}
		}
		
	}
	
}
