﻿
package net.kaikoga.fusalg.mortal.bullet {
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.field.Field;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class FireBullet extends ABullet {
		
		private static const BOUND:Rectangle = new Rectangle( -4, -4, 8, 8);
		private static const SHIFT:Point = new Point(-8, -8);
		private static const DEG_TO_RAD:Number = Math.PI/180;
		
		private var dx:int;
		private var dy:int;
		
		public function FireBullet(speed:int, aim:Number) {
			super(Chips.getInstance().magicChipM);
			this.chipName = "flame1";
			this.projectileDamage = 20;
			this.projectileBound = BOUND;
			this.chipShift = SHIFT;
			this.dx = Math.sin(aim * DEG_TO_RAD) * speed;
			this.dy = Math.cos(aim * DEG_TO_RAD) * speed;
		}
		
		override public function frameMove(field:Field):void {
			super.frameMove(field);
			this.frame++;
			this.chipName = (this.frame & 1) ? "flame1" : "flame2";
			this.position.x += this.dx;
			this.position.y += this.dy;
		}
	}
	
}
