﻿
package net.kaikoga.fusalg.mortal.effects {
	
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.chip.DotchipChipSet;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.AMortal;
	import net.kaikoga.fusalg.util.FusalgMath;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class ASimpleEffect extends AMortal {
		
		protected var dx:int;
		protected var dy:int;
		protected var life:int = 0;
		protected var blinkLife:int = 0;
		
		public function ASimpleEffect(chips:DotchipChipSet, d:int, dir:int = -1) {
			super(chips);
			this.dx = FusalgMath.randomInt( -d, d);
			this.dy = FusalgMath.randomInt( -d, d);
			switch (dir) {
				case DIR_RIGHT:
				this.dx += d;
				break;
				case DIR_UP:
				this.dy -= d;
				break;
				case DIR_LEFT:
				this.dx -= d;
				break;
				case DIR_DOWN:
				this.dy += d;
				break;
			}
		}
		
		override public function willDispose():Boolean {
			return (this.life | this.blinkLife) < 0;
		}
		
		override public function frameMove(field:Field):void {
			super.frameMove(field);
			this.position.x += this.dx;
			this.position.y += this.dy;
			if (this.life > 0) {
				this.life--;
			} else {
				this.blinkLife--;
			}
		}
		
		override public function drawSelf(field:Field):void {
			if (this.life | (this.blinkLife & 1)) {
				super.drawSelf(field);
			}
		}
	}
	
}
