﻿
package net.kaikoga.fusalg.mortal.effects {
	
	import flash.geom.Point;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.field.Field;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class LevelUpEffect extends ASimpleEffect {
		
		private static const SHIFT:Point = new Point(-32, -32);
		
		private var th:Number;
		
		public function LevelUpEffect(th:int = -1) {
			super(Chips.getInstance().levelupChipL, 0, 0);
			this.chipName = "spark1";
			this.chipShift = SHIFT;
			this.th = th / 4 * Math.PI;
			this.frame = -16;
			this.life = 48;
			this.blinkLife = 32767;
		}
		
		override public function willDispose():Boolean {
			return (this.frame > 128);
		}
		
		override public function frameMove(field:Field):void {
			super.frameMove(field);
			this.frame++;
			var avatarpos:Point = field.avatar.position;
			var th:Number = frame / 8 + this.th;
			this.position.x = avatarpos.x + 4 * this.frame * Math.sin(th);
			this.position.y = avatarpos.y + 4 * this.frame * Math.cos(th);
		}
		
	}
	
}
