﻿
package net.kaikoga.fusalg.mortal.enemye {
	
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.field.Cell;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.ACharacter;
	import net.kaikoga.fusalg.util.FusalgMath;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class AEnemyE extends ACharacter {
		
		private var state:String = "run";
		private var runNames:Array/*String*/;
		
		private var dx:int = 0;
		private var dy:int = 1;
		
		public function AEnemyE(runnames:Array) {
			super(Chips.getInstance().zombieChipM);
			this.chipName = runnames[0];
			this.runNames = runnames;
			this.projectileBound = new Rectangle(-12, -20, 24, 24);
			this.physicalBound = this.projectileBound;
		}
		
		public function run(field:Field, dx:int, dy:int):Boolean {
			this.frame++;
			this.chipName = runNames[(dx | dy) ? (this.frame >> 3) & 3 : 4];
			return this.moveSelf(field, dx, dy);
		}
		
		override public function frameMove(field:Field):void {
			super.frameMove(field);
			if (this.life <= 0) {
				return;
			}
			if (!this.run(field, dx, dy)) {
				this.dx = FusalgMath.randomInt( -1, 1);
				this.dy = FusalgMath.randomInt( -1, 2);
			}
			var xdiff:int = field.avatar.position.x - this.position.x;
			var ydiff:int = field.avatar.position.y - this.position.y;
			switch (this.dir) {
				case DIR_DOWN:
				if ((((xdiff < 0) ? -xdiff : xdiff) < 32) && (ydiff > 0)) {
					this.run(field, dx, dy);
				}
				break;
				case DIR_UP:
				if ((((xdiff < 0) ? -xdiff : xdiff) < 32) && (ydiff < 0)) {
					this.run(field, dx, dy);
				}
				break;
				case DIR_LEFT:
				if ((((ydiff < 0) ? -ydiff : ydiff) < 32) && (xdiff < 0)) {
					this.run(field, dx, dy);
				}
				break;
				case DIR_RIGHT:
				if ((((ydiff < 0) ? -ydiff : ydiff) < 32) && (xdiff > 0)) {
					this.run(field, dx, dy);
				}
				break;
			}
		}
		
	}
	
}
