﻿
package net.kaikoga.fusalg.mortal.npc {
	
	import flash.geom.Rectangle;
	import net.kaikoga.fusalg.audio.Sounds;
	import net.kaikoga.fusalg.chip.Chips;
	import net.kaikoga.fusalg.field.Field;
	import net.kaikoga.fusalg.mortal.ACharacter;
	import net.kaikoga.fusalg.mortal.AMortal;
	import net.kaikoga.fusalg.mortal.boss.BossPart;
	import net.kaikoga.fusalg.strings.FusalgStrings;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class WizardNPC extends ANPC {
		
		private var message:String;
		private var boss:ACharacter;

		private var handLeft:BossPart;
		private var handRight:BossPart;
		
		public function WizardNPC(message:String, boss:ACharacter) {
			super(Chips.getInstance().bossChipL, "wi_1", "wi_2", true);
			this.message = message;
			this.boss = boss;
			this.physicalBound = new Rectangle(0, 0, 64, 64);
			this.handLeft = new BossPart(this, Chips.getInstance().bossChipM, "wi_hl");
			this.handRight = new BossPart(this, Chips.getInstance().bossChipM, "wi_hr");
		}
		
		override public function onHitNPC(field:Field):void {
			field.messageLayer.flush();
			field.messageLayer.message(field, FusalgStrings.getString(this.message));
			this.life = 0;
			this.invincibleFrames = 96;
			if (this.boss) {
				field.addEnemy(this.boss);
				field.audioPlayer.trySwapAudio(Sounds.getInstance().music4);
			}
		}
		
		override public function onAdd(field:Field):void {
			super.onAdd(field);
			field.addPart(this.handLeft, 0, 48);
			field.addPart(this.handRight, 64, 48);
		}
		
		override public function onDispose(field:Field):void {
			super.onDispose(field);
			this.handLeft.dispose();
			this.handRight.dispose();
		}
		
	}
	
}
