﻿
package net.kaikoga.fusalg.util {
	
	import flash.events.IEventDispatcher;
	import net.kaikoga.text.TextDownEvent;
	
	/**
	 * ...
	 * @author kaikoga
	 */
	public class KeyStateListener {
		
		public var keyState:KeyState;
		
		public function KeyStateListener(keystate:KeyState) {
			super();
			this.keyState = keystate;
		}
		
		private function textDownEventToKeyName(event:TextDownEvent):String {
			switch (event.charCode) {
				case TextDownEvent.LEFT:
				return "LEFT";
				case TextDownEvent.RIGHT:
				return "RIGHT";
				case TextDownEvent.UP:
				return "UP";
				case TextDownEvent.DOWN:
				return "DOWN";
				case 0x0a:
				return "ENTER";
				case TextDownEvent.BACKSPACE:
				return "BS";
				case TextDownEvent.TAB:
				return "TAB";
			}
			return event.text;
		}
		
		private function onTextDown(event:TextDownEvent):void {
			var text:String = textDownEventToKeyName(event);
			this.keyState.setStateOfKey(text, true);
			this.keyState.queueEvent(new KeyEventRecord(this.textDownEventToKeyName(event), KeyEventRecord.KEY_DOWN));
		}
		
		private function onTextUp(event:TextDownEvent):void {
			var text:String = textDownEventToKeyName(event);
			this.keyState.setStateOfKey(text, false);
			this.keyState.queueEvent(new KeyEventRecord(this.textDownEventToKeyName(event), KeyEventRecord.KEY_UP));
		}

		public function listen(tds:IEventDispatcher):void {
			tds.addEventListener(TextDownEvent.TEXT_DOWN, this.onTextDown);
			tds.addEventListener(TextDownEvent.TEXT_UP, this.onTextUp);
		}

		public function purge(tds:IEventDispatcher):void {
			tds.removeEventListener(TextDownEvent.TEXT_DOWN, this.onTextDown);
			tds.removeEventListener(TextDownEvent.TEXT_UP, this.onTextUp);
		}

	}
	
}
